angular.module('app.controllers')

    .controller('AlertsCtrl', function($scope, $rootScope, $state, $stateParams, $ionicModal, $ionicViewService, AlertService) {
        console.log("AlertsCtrl");
        trackView('ricerca alert');

        var currentUser = getCurrentUser();
        var currentModel;   //memorizza il modello corrente per la ricerca paginata

        $scope.model = {sub: '', pan: '', periodo: 'W', tipo: ''};
        $scope.hasMoreData = false;
        $scope.showNoResultsFoundMessage = false;
        if (currentUser.profiloSingolaCarta) $scope.model.pan = currentUser.pan;
        if (currentUser.subProfile){ $scope.model.sub = currentUser.codiceSub; }
        if (!currentUser.mainProfile && currentUser.clienti && currentUser.clienti.length == 1){
            $scope.model.sub = currentUser.clienti[0].codice;
        }

        $ionicModal.fromTemplateUrl('templates/alert/ricerca.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (popover) {
            $scope.modalSearch = popover;
            $rootScope.registerModal(popover);
            if (CACHE.results === undefined){
                $scope.showSearch();
            }
        });

        $scope.showSearch = function () {
            console.log(" alerts showSearch");
            $scope.modalSearch.show();
        };

        $scope.filtri = obtainCachedFilter('filtriAlert');

        $scope.cerca = function(model){
            if ($scope.modalSearch) {
                $scope.modalSearch.hide();
                //ricerca manuale
                $scope.showNoResultsFoundMessage = true;
                setCachedFilter('filtriAlert', $scope, model);
            }
            AlertService.ricerca(model).then(function(response) {
                if (response.data) {
                    $scope.results = response.data;
                    CACHE.results = $scope.results;
                }
            });
        };

        $scope.closeModal = function(){
            $scope.modalSearch.hide();
            var view = $ionicViewService.getBackView();
            if (view) view.go();
        };

        $scope.dettaglio = function(index){
            var alert = $scope.results[index];

            store('dettaglio-alert', alert);
            $state.transitionTo('dettaglio-alert');
        };

        if ($scope.$navDirection == "back"){
            $scope.results = CACHE.results;
        } else {
            //ricerca di default
            // $scope.cerca($scope.model);
        }

    })

    .controller('DettaglioAlertCtrl', function($scope, $translate) {
        console.log("DettaglioAlertCtrl");

        trackView('dettaglio alert');

        $scope.item = retrieve('dettaglio-alert');

        $scope.alertTypes = {
            "TRS_TIME_SPEC": $translate.instant("alert-type-trs_time_spec"),
            "KM_DIFF": $translate.instant("alert-type-km_diff"),
            "LITER_DAILY": $translate.instant("alert-type-liter_daily"),
            "EURO_DAILY": $translate.instant("alert-type-euro_daily"),
            "IMP_LIM": $translate.instant("alert-type-imp_lim"),
            "TRS_DAY_SPEC": $translate.instant("alert-type-trs_day_spec"),
            "EXT_RESID_FLAG": $translate.instant("alerts-tipo-perc-plafond")
        };
    })

    .controller('AlertCartaCtrl', function($scope, $rootScope, $state, $stateParams, $ionicModal, $ionicViewService, AlertService) {
        console.log("AlertCartaCtrl");
        trackView('ricerca alert plus');

        var currentUser = getCurrentUser();
        var currentModel;   //memorizza il modello corrente per la ricerca paginata

        $scope.model = {sub: '', pan: '', periodo: 'W', tipo: ''};
        $scope.hasMoreData = false;
        $scope.showNoResultsFoundMessage = false;

        if (currentUser.profiloSingolaCarta) $scope.model.pan = currentUser.pan;
        if (currentUser.subProfile){ $scope.model.sub = currentUser.codiceSub; }
        if (!currentUser.mainProfile && currentUser.clienti && currentUser.clienti.length == 1){
            $scope.model.sub = currentUser.clienti[0].codice;
        }

        $ionicModal.fromTemplateUrl('templates/alert/ricerca_carta.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (popover) {
            $scope.alertCartaSearch = popover;
            $rootScope.registerModal(popover);
            if (CACHE.results_carta === undefined){
                $scope.showSearch();
            }
        });

        $scope.showSearch = function () {
            console.log(" alert carta showSearch");
            $scope.alertCartaSearch.show();
        };

        $scope.filtri = obtainCachedFilter('filtriAlertCarta');

        $scope.cerca = function(model){
            if ($scope.alertCartaSearch) {
                $scope.alertCartaSearch.hide();
                //ricerca manuale
                $scope.showNoResultsFoundMessage = true;
                setCachedFilter('filtriAlertCarta', $scope, model);
            }
            AlertService.ricercaCarte(model).then(function(response) {
                if (response.data) {
                    $scope.results = response.data;
                    CACHE.results_carta = $scope.results;
                }
            });
        };

        $scope.closeModal = function(){
            $scope.alertCartaSearch.hide();
            var view = $ionicViewService.getBackView();
            if (view) view.go();
        };

        $scope.dettaglio = function(index){
            var alert = $scope.results[index];
            store('dettaglio-alert-carta', alert);
            $state.transitionTo('dettaglio-alert-carta');
        };

        if ($scope.$navDirection == "back"){
            $scope.results = CACHE.results_carta;
        } else {
            //ricerca di default
            // $scope.cerca($scope.model);
        }

    })

    .controller('DettaglioAlertCartaCtrl', function($scope, $translate) {
        console.log("DettaglioAlertCartaCtrl");

        trackView('dettaglio alert plus');

        $scope.item = retrieve('dettaglio-alert-carta');

        var alertTypes = {
            "I": $translate.instant("alert-type-plus-import"),
            "L": $translate.instant("alert-type-plus-volume")
        };

        $scope.item.descrTipo = alertTypes[item.tipo];
    })