angular.module('app.controllers')

    .controller('AutistiCtrl', function($scope, $rootScope, $state, $ionicPopup, $ionicModal, $translate, AutistiService, CarteService) {
        console.log("AutistiCtrl");
        trackView($state.current.name);

        var currentUser = getCurrentUser();
        var pageCount = 0;
        var currentModel;   //memorizza il modello corrente per la ricerca paginata

        var currentCard = CarteService.currentCard;

        $scope.model = { codice: '', tipoPin: currentCard.tipoPin };
        $scope.hasMoreData = false;
        $scope.showNoResultsFoundMessage = false;

        
        $ionicModal.fromTemplateUrl(
        	'templates/autisti/ricerca.html',
	        {
                scope: $scope,
                animation: 'slide-in-up'
            }
        )
        .then(function (popover) {
            $scope.modalSearch = popover;

            if (CACHE.autistiResults === undefined){
                $scope.showSearch();
            } else {
                $scope.results = CACHE.autistiResults;
            }
        });

        $scope.showSearch = function () {
            $scope.modalSearch.show();
        };

        $scope.filtri = obtainCachedFilter('filtriPinAutista');

        $scope.cerca = function(model){
            currentModel = model;

            if ($scope.modalSearch) {
                $scope.modalSearch.hide();
                $scope.showNoResultsFoundMessage = true;
                setCachedFilter('filtriPinAutista', $scope, model);
            }

	        AutistiService.ricerca(model).then(function(response) {
                if (response.data) {
                    $scope.results = response.data.content;
                    pageCount = 1;
                    $scope.hasMoreData = response.data.hasNext;
                    CACHE.autistiResults = $scope.results;
                    CACHE.pageCount = pageCount;
                }
            });
        };

        $scope.closeModal = function(){
            $scope.modalSearch.hide();
        };

        $scope.loadMore = function() {
            if ($scope.hasMoreData) {
	            AutistiService.ricerca(currentModel, pageCount).then(function(response) {
                    if (response.data) {
                        for (var i = 0; i < response.data.content.length; i++) {
                            $scope.results.push(response.data.content[i]);
                        }

                        pageCount++;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.hasMoreData = response.data.hasNext;
                        CACHE.autistiResults = $scope.results;
                        CACHE.pageCount = pageCount;
                    }
                });
            }
        };

	    $scope.dettaglio = function(codiceAutista){
		    $state.transitionTo('visualizza-pin', {codiceAutista: codiceAutista})
        };

        if ($scope.$navDirection === "back"){
            $scope.results = CACHE.autistiResults;
            pageCount = CACHE.pageCount;
        }
    })

    .controller('StoricoPinAutistaCtrl', function ($scope, $rootScope, $state, $stateParams, $ionicModal, $translate, $ionicLoading, SecurityService, CarteService) {
        console.log("StoricoPinAutistaCtrl");

        trackView($state.current.name);

        var currentUser = getCurrentUser();
        var pageCount = 0;
        var currentModel;   //memorizza il modello corrente per la ricerca paginata
        var currentCard = CarteService.currentCard;

        $scope.model = {sub: '', pan: '', tipoPin: currentCard.tipoPin};
        $scope.hasMoreData = false;
        $scope.showNoResultsFoundMessage = false;
        if (currentUser.subProfile) {
            $scope.model.sub = currentUser.codiceSub;
        }
        // if (!currentUser.mainProfile && currentUser.clienti && currentUser.clienti.length === 1) {
        //     currentUser.clienti[0].codice;
        // }

        $ionicModal.fromTemplateUrl(
            'templates/autisti/ricerca.html',
            {
                scope: $scope,
                animation: 'slide-in-up'
            }
        ).then(function (popover) {
                $scope.modalSearch = popover;
                $rootScope.registerModal(popover);
                if (!currentUser.profiloSingolaCarta && CACHE.autistiResults === undefined) {

                    $scope.showSearch();
                } else if (currentUser.profiloSingolaCarta){
                    //utente con singola carta, effettuo ricerca immediata
                    $scope.cerca($scope.model);
                }
            });

        $scope.showSearch = function () {
            console.log(" autisti showSearch");
            $scope.modalSearch.show();
        };

        $scope.filtri = obtainCachedFilter('filtriStoricoPin');

        $scope.cerca = function (model) {
            currentModel = model;
            if ($scope.modalSearch) {
                $scope.modalSearch.hide();
                $scope.showNoResultsFoundMessage = true;
                setCachedFilter('filtriStoricoPin', $scope, model);
            }
            SecurityService.storicoPin(model).then(function (response) {
                if (response.data) {
                    $scope.results = response.data.content;
                    pageCount = 1;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.hasMoreData = response.data.hasNext;
                    CACHE.autistiResults = $scope.results;
                    CACHE.pageCount = pageCount;
                }
            });
        };

        $scope.closeModal = function () {
            $scope.modalSearch.hide();
        };
    });