angular.module('app.controllers')

    .controller('CarteCtrl', function($scope, $rootScope, $state, $stateParams, $ionicPopup, $ionicModal, $translate, $ionicViewService, CarteService, ProfileService) {
        console.log("CarteCtrl", $state);
        trackView($state.current.name);

        // se state = ricerca-generacodice-carte|ricerca-storicocodici-carte|ricerca-pin-temporaneo-carta
        // mettere filtro solo su carte attive

        var currentUser = getCurrentUser();
        var pageCount = 0;
        var currentModel;   //memorizza il modello corrente per la ricerca paginata
        var statoBlocco = '';
        
        //abilito il flag per la ricerca delle sole carte attive
        if ($state.current.name === 'ricerca-generacodice-carte' ||
            $state.current.name === 'ricerca-storicocodici-carte' ||
            $state.current.name === 'ricerca-visualizza-pin' ||
            $state.current.name === 'ricerca-dpayment' ||
            $state.current.name === 'ricerca-storico-sblocchi-dpay' ||
            $state.current.name === 'ricerca-dashboard-pin-carta' ||
            $state.current.name === 'ricerca-dashboard-pin-autista' ||
            $state.current.name === 'ricerca-pin-temporaneo-carta'){
            statoBlocco = 'A';
        }
    
        $scope.model = { sub: '', pan: '', statoBlocco: statoBlocco };
        $scope.hasMoreData = false;
        $scope.showNoResultsFoundMessage = false;

        if (currentUser.subProfile){ $scope.model.sub = currentUser.codiceSub; }
        if (!currentUser.mainProfile && currentUser.clienti && currentUser.clienti.length === 1){
            $scope.model.sub = currentUser.clienti[0].codice;
        }

        $ionicModal.fromTemplateUrl('templates/carte/ricerca.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (popover) {
            $scope.modalSearch = popover;
            $rootScope.registerModal(popover);

            if (CACHE.results === undefined){
                $scope.showSearch();
            }
        });

        $ionicModal.fromTemplateUrl('templates/dpayment/never-ask-again-favorite-payments-confirm.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(popover) {
            $scope.modalFavoritePayments = popover;
            $rootScope.registerModal(popover);
        });

        $scope.showSearch = function () {
            console.log(" carte showSearch");
            $scope.modalSearch.show();
        };

        // if (currentUser.subProfile){
        //     $scope.model.sub = currentUser.codiceSub;
        // }

        if (statoBlocco !== '') {
            $scope.filtri = obtainCachedFilter('filtriCarteStato');
        } else {
            $scope.filtri = obtainCachedFilter('filtriCarte');
        }


        $scope.cerca = function(model){
            currentModel = model;
            if ($scope.modalSearch) {
                $scope.modalSearch.hide();
                //ricerca manuale
                $scope.showNoResultsFoundMessage = true;
                if (statoBlocco !== '') {
                    setCachedFilter('filtriCarteStato', $scope, model);
                } else {
                    setCachedFilter('filtriCarte', $scope, model);
                }
            }
            CarteService.ricerca(model).then(function(response) {
                if (response.data) {
                    $scope.results = response.data.content;
                    pageCount = 1;
                    $scope.hasMoreData = response.data.hasNext;
                    CACHE.results = $scope.results;
                    CACHE.pageCount = pageCount;
                }
            });
        };

        $scope.closeModal = function(){
            $scope.modalSearch.hide();
            var view = $ionicViewService.getBackView();
            if (view) view.go();
        };

        $scope.closeModalFavoritePayments = function(){
            $scope.modalFavoritePayments.hide();
        };

        $scope.loadMore = function() {
            if ($scope.hasMoreData) {
                CarteService.ricerca(currentModel, pageCount).then(function(response) {
                    if (response.data) {
                        for (var i = 0; i < response.data.content.length; i++) {
                            $scope.results.push(response.data.content[i]);
                        }

                        pageCount++;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.hasMoreData = response.data.hasNext;
                        CACHE.results = $scope.results;
                        CACHE.pageCount = pageCount;
                    }
                });
            }
        };

        $scope.dettaglio = function(pan){
            var carta;
            for (var i = 0; i < $scope.results.length; i++) {
                if ($scope.results[i].pan === pan){
                    carta = $scope.results[i];
                    i = $scope.results.length;
                }
            }

            CarteService.currentCard = carta;

            console.log("Set currentCard " + carta.pan, carta);


            if (!carta.bloccata && $state.current.name === "ricerca-dashboard-pin-carta") {
                $rootScope.gotoDashboardPin(pan);
            } else if (!carta.bloccata && $state.current.name === "ricerca-pin-temporaneo-carta") {
                $rootScope.generaPinTemporaneo(pan);
            } else if (!carta.bloccata && $state.current.name === "ricerca-generacodice-carte"){
                $rootScope.generaCodice(pan);
            } else if (!carta.bloccata && $state.current.name === "ricerca-visualizza-pin"){
                $rootScope.visualizzaPin(pan);
            } else if (!carta.bloccata && $state.current.name === "ricerca-storicocodici-carte"){
                $rootScope.storicoCodici(carta.pan);
            } else if (!carta.bloccata && $state.current.name === "ricerca-storico-sblocchi-dpay"){
                $rootScope.storicoSblocchiDPayment(carta.pan);
            } else if (!carta.bloccata && $state.current.name === "ricerca-blocco-carte"){
                $rootScope.blocca(carta.pan)
            } else if (!carta.bloccata && $state.current.name === "ricerca-dpayment" ){

                console.log("$stateParams.askFavorite", $stateParams.askFavorite);

                //$stateParams.askFavorite -> true || 'true'
                if ($stateParams.askFavorite === true || $stateParams.askFavorite === 'true' ){
                    //richiesta conferma carta

                    $scope.data = { neverAskFlag: false, carta: carta };
                    $scope.modalFavoritePayments.show();

                } else {
                    $rootScope.sceltaPuntoVendita(carta.pan);
                }

            } else if (carta.bloccata && $state.current.name === "ricerca-blocco-carte"){

                if (!currentUser.abilitatoSbloccoCarta){
                    $ionicPopup.alert({
                        title: $translate.instant("alert-title-sblocco-carta"),
                        template: $translate.instant("permission-unlock-card-absent")
                    });
                    return;
                }

	            $ionicPopup.confirm({
	                title: $translate.instant("alert-title-sblocco-carta"),
	                template: $translate.instant("alert-template-sblocco-confirm", { pan: carta.pan } )
	            }).then(function(res) {
	                if(res) {
	                    CarteService.sblocca(carta).then( function(response){

	                        if (null != response.data.errorMessage){
	                            $ionicPopup.alert({template: response.data.errorMessage,
	                                title: $translate.instant("alert-title-attenzione")});
	                        } else {
	                            $ionicPopup.alert({template: $translate.instant("alert-template-carta-sbloccata"),
	                                title: $translate.instant("alert-title-info")});
	                            carta.bloccata = false;
	                            //aggiorno la cache
	                            if (CACHE.results){
	                                for (var i= 0; i<CACHE.results.length; i++){
	                                    if (CACHE.results[i].pan == carta.pan) CACHE.results[i].bloccata = false;
	                                }
	                            }

	                            //aggiornare il profilo
                                ProfileService.checkUser().then(function (result) {
                                    if (result) {
                                        $rootScope.currentUser = result;
                                    }
                                })

	                        }
	                    });
	                } else {
	                    //console.log('You are not sure');
	                }
	            });
            }
            else {
                // store('dettaglio-carta', carta);
                $state.transitionTo('dettaglio-carta');
            }

        };

        //conferma il pan carta
        $scope.confirmFavoritePayment = function(pan){
            store(PROFILEKEYS.FAVORITE_PAYMENTS_CARD_NEVER_ASK_FLAG, true);
            store(PROFILEKEYS.FAVORITE_PAYMENTS_CARD, pan);
            $scope.modalFavoritePayments.hide();
            $rootScope.sceltaPuntoVendita(pan);
        };

        //non conferma il pan carta
        $scope.notConfirmFavoritePayment = function(neverAskFlag, pan){
            if (neverAskFlag){
                store(PROFILEKEYS.FAVORITE_PAYMENTS_CARD_NEVER_ASK_FLAG, neverAskFlag);
            }
            $scope.modalFavoritePayments.hide();
            $rootScope.sceltaPuntoVendita(pan);
        };

        $scope.cancelFavoritePayment = function(){
            $scope.modalFavoritePayments.hide();
        };

        if ($scope.$navDirection === "back"){
            $scope.results = CACHE.results;
            pageCount = CACHE.pageCount;
        } else {
            //non provengo dal back
      //disattivo la ricerca automatica
      // $scope.cerca ($scope.model);
        }
    })

    .controller('DettaglioCartaCtrl', function($scope, $rootScope, $stateParams, $state, $ionicPopup, $translate, CarteService, ProfileService) {
        console.log("DettaglioCartaCtrl");

        trackView($state.current.name);

        var currentUser = getCurrentUser();
        if (currentUser.profiloSingolaCarta){
            //carico esplicitamente il dettaglio della carta
            CarteService.ricerca({ sub:'', pan:currentUser.pan }).then(function(response) {
                if (response.data.content && response.data.content.length > 0) {
                    $scope.item = response.data.content[0];
                    plafond();  //recupera il plafond
                }
            });
        } else {
            $scope.item = CarteService.currentCard;
            plafond();  //recupera il plafond
        }

        $scope.plafond = {};

        function plafond(){
            CarteService.plafond($scope.item.pan).then(function(result){
                if (result.data.value) $scope.plafond = result.data.value;

                //if (result.data.errorMessage)
                //    $ionicPopup.alert({template: result.data.errorMessage,
                //        title: "Recupero Plafond"});
            })
        }

        $scope.transazioni = function(pan){
            $state.go('transazioni-carta', {pan: pan});
        };

        $scope.sblocca = function(data){

            $ionicPopup.confirm({
                title: $translate.instant("alert-title-sblocco-carta"),
                template: $translate.instant("alert-template-sblocco-confirm", { pan: $stateParams.pan})
            }).then(function(res) {
                if(res) {
                    CarteService.sblocca(data).then( function(response){

                        if (null != response.data.errorMessage){
                            $ionicPopup.alert({template: response.data.errorMessage,
                                title: $translate.instant("alert-title-attenzione")});
                        } else {
                            $ionicPopup.alert({template: $translate.instant("alert-template-carta-sbloccata"),
                                title: $translate.instant("alert-title-info")});
                            $scope.item.bloccata = false;
                            //aggiorno la cache
                            if (CACHE.results){
                                for (var i= 0; i<CACHE.results.length; i++){
                                    if (CACHE.results[i].pan == data.pan) CACHE.results[i].bloccata = false;
                                }
                            }
                            //aggiornare il profilo
                            ProfileService.checkUser().then(function (result) {
                                if (result) {
                                    $rootScope.currentUser = result;
                                }
                            })
                        }
                    });
                } else {
                    //console.log('You are not sure');
                }
            });
        }
    })

    .controller('BloccoCartaCtrl', function($scope, $rootScope, $state, $stateParams, $ionicPopup, $ionicViewService, $translate, CarteService, ProfileService) {
        console.log("BloccoCartaCtrl");

        trackView($state.current.name);

        $scope.causaliBlocco = [];
        $scope.form = {pan: $stateParams.pan, causaleBlocco: ''};

        CarteService.causaliBlocco().then(function(response){
            $scope.causaliBlocco = response.data;
        });

        $scope.confermaBlocco = function(form){
            $ionicPopup.confirm({
                title: $translate.instant("alert-title-blocco-carta"),
                template: $translate.instant("alert-template-blocco-confirm", { pan: $stateParams.pan})
            }).then(function(res) {
                if(res) {
                    CarteService.blocca(form).then( function(response){

                        if (null != response.data.errorMessage){
                            $ionicPopup.alert({template: response.data.errorMessage,
                                title: $translate.instant("alert-title-attenzione")});
                        } else {
                            $ionicPopup.alert({template: $translate.instant("alert-template-carta-bloccata"),
                                title: $translate.instant("alert-title-info")});

                            var item = CarteService.currentCard;
                            if (item != null) {
                                item.bloccata = true;
                                //store('dettaglio-carta', item);
                                //aggiorno la cache
                                if (CACHE.results) {
                                    for (var i = 0; i < CACHE.results.length; i++) {
                                        if (CACHE.results[i].pan == form.pan) CACHE.results[i].bloccata = true;
                                    }
                                }
                            }

                            //aggiornare il profilo
                            ProfileService.checkUser().then(function (result) {
                                if (result) {
                                    $rootScope.currentUser = result;
                                }
                            })

                            $ionicViewService.getBackView().go();
                        }
                    });
                } else {
                    //console.log('You are not sure');
                }
            });
        }
    });