angular.module('app.controllers')

    .controller('GeneraCodiceCartaCtrl', function($scope, $rootScope, $state, $stateParams, $ionicPopup, $ionicModal, $ionicLoading, $ionicViewService, $timeout, $translate, CodiciCarteService, BiometricService, CarteService) {
        console.log("GeneraCodiceCartaCtrl");

        // trackView('genera codice carta');
        trackView($state.current.name);

        //verifica permessi carta
        var currentCard = CarteService.currentCard;
        if (currentCard.tipoPin == 4 || currentCard.tipoPin == 5 ){
            $ionicPopup.alert({template: $translate.instant("carta-non-abilitata-codici-pagamento"),
                title: $translate.instant("alert-title-attenzione")}).then(function(){

                $rootScope.goto('private-dashboard');
            });

        }

        $scope.$on("onPause", function (event, data) {
            onPause();
        });
        $scope.$on("onResume", function (event, data) {
            onResume();
        });

        var checkLoop = true;
        var fingerprintEnabled = false;
        var userAborted = false;

        $ionicModal.fromTemplateUrl('templates/carte/fueling-completed-confirm.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(popover) {
            $scope.modalFuleingCompleted = popover;
            $rootScope.registerModal(popover);
        });

        $scope.closeModalFuleingCompleted = function(){
            $scope.modalFuleingCompleted.hide();
            if (userAborted){
                //todo: gestire la casistica in modo diverso?
                // var view = $ionicViewService.getBackView();
                // if (view) view.go();
            } else {

            }

            $rootScope.goto('private-dashboard');
        };
        
        //verifico la presenza della password salvata
        if (window.plugins && window.plugins.touchid) {
            if (BiometricService.getBiometricCodesProtectionConfig()) {
                window.plugins.touchid.has(CONFIG.biometricLoginKey, function () {
                    fingerprintEnabled = true;
                }, function () {
                    fingerprintEnabled = false;
                });
            }
        }

        function onResume(){
            checkLoop = true;
            console.log("onresume");
            checkStatoCodici();
        }

        function onPause(){
            checkLoop = false;
            console.log("onpause");
        }

        var initializing = true;
        var codicePagamento;
        $scope.formData = { durata: '', km: '' };

        var profile = retrieve('profile');

        //se sono sub o driver
        var pan = $stateParams.pan || profile.pan;

        //verifico lo stato dei codici
        function checkStatoCodici(){

            CodiciCarteService.getStatoCodici(pan).then(
                function(response){

                    console.log("getStatoCodici", response);

                    if (response.errorMessage != null){
                        $ionicPopup.alert({template: $translate.instant(response.errorMessage),
                            title: $translate.instant("alert-title-attenzione")});
                    } else {

                        initializing = false;
                        codicePagamento = response.value;
                        $scope.codicePagamento = codicePagamento;

                        //todo: codicePagamento.stato == 'U' -> mostrare popup riepilogativo
                        //inviare push notifications
                        //erogazione completata

                        if (codicePagamento) {
                            console.log("codicePagamento.codiceCreato", codicePagamento.stato);
                            if (codicePagamento.codiceUtilizzato) {
                                $scope.modalFuleingCompleted.show();
                            }
                            renderBarcode(codicePagamento.codice);
                        }
                    }

                    //una volta creato mando in loop ogni 30 secondi
                    if (canLoop()) $timeout( function(){ checkStatoCodici() }, CONFIG.DPAY_POLLING);

                },
                function (error){

                    // $ionicPopup.alert({template: $translate.instant(error.errorMessage),
                    //     title: $translate.instant("alert-title-attenzione")});

                })

        }

        checkStatoCodici();

        /* renderizza il barcode del codice di pagamento */
        function renderBarcode(codice){
            JsBarcode("#barcode-pagamento", codice, {
                format: "CODE128",
                width:4,
                height:80,
                displayValue: false
            });
        }

        /*
        //todo: cambiare meccanismo vedi dpay
        loop per verificare lo stato di un codice.
         */
        function canLoop(){
            return checkLoop && codicePagamento !== null && codicePagamento.codiceCreato && $state.current.name === "generacodice-carte";
        }

        $scope.isInitializingService = function(){
            return initializing;
        }

        $scope.canCreateCode = function(){
            return !initializing && !(codicePagamento && codicePagamento.codiceCreato )
        }
        
        $scope.selezionaDurata = function(durata){
            $scope.formData.durata = durata;
        }

        $scope.isBtnCodiceDisabled = function(){
            return $scope.formData.durata === '';
        }
        
        $scope.generaCodicePagamento = function(formData){
            if (window.plugins && window.plugins.touchid) {

                window.plugins.touchid.isAvailable(
                    function(){

                        if (fingerprintEnabled && BiometricService.getBiometricCodesProtectionConfig()) {
                            window.plugins.touchid.verify(CONFIG.biometricLoginKey, "Verifica identità per generazione codice", function (password) {
                                _generaCodice(formData)
                            });

                        } else {
                            //touch id available but not enabled
                            _generaCodice(formData)
                        }
                    },
                    function(msg){
                        // touch Id not availlable
                        _generaCodice(formData)
                    })

            } else {
                //touch id plugin not present
                _generaCodice(formData)
            }
            
        } 
        
        function _generaCodice (formData){
            $ionicLoading.show();    
            CodiciCarteService.generaCodice(pan, formData.km, formData.durata).then(
                function(response){
                    $ionicLoading.hide();

                    if (response.errorMessage != null){
                        $ionicPopup.alert({template: $translate.instant(response.errorMessage),
                            title: $translate.instant("alert-title-attenzione")});
                    } else {

                        initializing = false;
                        codicePagamento = response.value;
                        $scope.codicePagamento = codicePagamento;
                        renderBarcode(codicePagamento.codice);
                        checkStatoCodici();
                    }

                },
                function (error){
                    $ionicLoading.hide();
                    $ionicPopup.alert({template: $translate.instant(error.errorMessage),
                        title: $translate.instant("alert-title-attenzione")});

                })
            
        }

        $scope.annullaCodice = function(){
            $ionicLoading.show();
            CodiciCarteService.annullaCodice(codicePagamento.codice, pan).then(
                function(response){
                    $ionicLoading.hide();

                    if (response.errorMessage != null){
                        $ionicPopup.alert({template: $translate.instant(response.errorMessage),
                            title: $translate.instant("alert-title-attenzione")});
                    } else {
                        userAborted = true;
                        $ionicPopup.alert({template: $translate.instant("codice-pagamento-annullato-msg"),
                            title: $translate.instant("alert-title-info")}).then(function(){

                            initializing = false;
                            codicePagamento = response.value;
                            $scope.formData.durata = '';
                            $scope.formData.km = '';
                            $scope.codicePagamento = codicePagamento;
                            
                        })
                    }
                },
                function (error){
                    $ionicLoading.hide();
                    $ionicPopup.alert({template: $translate.instant(error.errorMessage),
                        title: $translate.instant("alert-title-attenzione")});

                })
        }
        
    })

    .controller('StoricoCodiciCartaCtrl', function($scope, $state, $stateParams, $ionicPopup, $ionicLoading, $ionicViewService, $translate, CodiciCarteService) {
        console.log("StoricoCodiciCartaCtrl");

        // trackView('storico codice carta');
        trackView($state.current.name);

        var profile = retrieve('profile');
        
        //se sono sub o driver
        var pan = $stateParams.pan || profile.pan;
        
        $scope.results = [];
        $scope.pan = pan;

        // document.addEventListener("pause", onPause, false);
        // document.addEventListener("resume", onResume, false);

        $scope.$on("onResume", function (event, data) { onResume(); });

        function onResume(){
            if ($state.current.name === 'storicocodici-carte' ) {
                loadStorico();
            }
        }

        // function onPause(){}

         var loadStorico = function(){
            $ionicLoading.show();
            CodiciCarteService.getListaCodici(pan).then(
                function(response){
                    $ionicLoading.hide();
                    if (response.errorMessage != null){
                        $ionicPopup.alert({template: $translate.instant(response.errorMessage),
                            title: $translate.instant("alert-title-attenzione")});
                    } else {

                        $scope.results = response.value;
                    }

                },
                function (error){
                    $ionicLoading.hide();
                    $ionicPopup.alert({template: $translate.instant(error.errorMessage),
                        title: $translate.instant("alert-title-attenzione")});

                })
        };

        loadStorico();

    })

    
