angular.module('app.controllers')

    .controller('FattureCtrl', function($scope, $rootScope, $state, $stateParams, $ionicModal, $ionicViewService, FattureService) {
        console.log("FattureCtrl");
        trackView('ricerca fatture');

        var currentUser = getCurrentUser();
        $scope.hasMoreData = false;
        $scope.showNoResultsFoundMessage = false;

        var annoCorrente = new Date().getFullYear();

        $scope.model = {sub: '', anno: annoCorrente, mese: ''};
        $scope.anni = [annoCorrente, annoCorrente-1, annoCorrente-2];

        if (currentUser.profiloSingolaCarta) $scope.model.pan = currentUser.pan;
        if (currentUser.subProfile){ $scope.model.sub = currentUser.codiceSub; }
        if (!currentUser.mainProfile && currentUser.clienti && currentUser.clienti.length == 1){
            $scope.model.sub = currentUser.clienti[0].codice;
        }

        $ionicModal.fromTemplateUrl('templates/fatture/ricerca.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (popover) {
            $scope.modalSearch = popover;
            $rootScope.registerModal(popover);

            if (CACHE.results === undefined){
                $scope.showSearch();
            }
        });

        $scope.showSearch = function () {
            console.log(" fatture showSearch");
            $scope.modalSearch.show();
        };

        $scope.filtri = obtainCachedFilter('filtriFatture');

        $scope.cerca = function(model){
            if ($scope.modalSearch) {
                $scope.modalSearch.hide();
                //ricerca manuale
                $scope.showNoResultsFoundMessage = true;
                setCachedFilter('filtriFatture', $scope, model);
            }
            FattureService.ricerca(model).then(function(response) {
                if (response.data) {
                    $scope.results = response.data;
                    CACHE.results = $scope.results;
                }
            });
        };

        $scope.closeModal = function(){
            $scope.modalSearch.hide();
            var view = $ionicViewService.getBackView();
            if (view) view.go();
        };

        $scope.scarica = function(numero){
            var fattura;
            for (var i = 0; i < $scope.results.length; i++) {
                if ($scope.results[i].numero == numero){
                    fattura = $scope.results[i];
                    i = $scope.results.length;
                }
            }
            FattureService.download(fattura);

        };

        if ($scope.$navDirection == "back"){
            $scope.results = CACHE.results;
        } else {
            //ricerca di default
            // $scope.cerca($scope.model);
        }
    })

    .controller('DettaglioFatturaCtrl', function($scope) {
        console.log("DettaglioFatturaCtrl");

        trackView('dettaglio fattura');

        $scope.item = retrieve('dettaglio-fattura');
    })
  