angular.module('app.controllers')

    .controller('LoginCtrl', function($scope, $rootScope, $ionicLoading, $state, $ionicPopup, $ionicViewService, $window, $translate, LoginService, BiometricService) {
        console.log("LoginCtrl");

        trackView($state.current.name);

        if ($rootScope.currentUser == null || $rootScope.currentUser.authToken == null) {
            if (window.plugins && window.plugins.touchid) {
                //mostro la schermata per il riconoscimento biometrico, se non l'ho mai chiesto prima
                window.plugins.touchid.isAvailable(function () {

                    //richiedo autenticazione
                    if (BiometricService.getBiometricLoginProtectionConfig()) {
                        window.plugins.touchid.verify(CONFIG.biometricLoginKey,
                            $translate.instant("touch-id-login-message"),
                            function(password) {
                                var auth = password.split("__SEPARATOR__");
                                $rootScope.login({ username: auth[0], password: auth[1] });
                            });
                    }

                }, function (msg) {
                    console.log("Fingerprint not available");
                });
            }
        }


        $scope.loginData = {username:"" ,password:""};
        $scope.biometricLoginEnabled = false;

        var profile = retrieve('profile');
        if (profile){
            $scope.loginData.username = profile.username;
        } else {
            var lastUsername = retrieve('lastUsername');
            if (lastUsername){
                $scope.loginData.username = lastUsername;
            }
        }

        var username = $scope.loginData.username;
        var password = $scope.loginData.password;

        if (username != null && password != null && username != "" && password != "") {
            $rootScope.login($scope.loginData);
        }

        $scope.keyPressed = function(keyEvent, formData) {
            if (keyEvent.keyCode === 13) {
                $rootScope.login(formData);
            }
        };

    })

    .controller('LoginBiometricSetupCtrl', function ($scope, $state, $stateParams, $rootScope, $ionicPopup, $translate, $ionicSideMenuDelegate, BiometricService) {
        trackView($state.current.name);

        $scope.isIOS = ionic.Platform.isIOS();
        $scope.isAndroid = ionic.Platform.isAndroid();

        $scope.$on('$stateChangeStart', function(ev){
            //$ionicView.afterEnter
            $ionicSideMenuDelegate.canDragContent(true);
        });

        $scope.$on('$stateChangeSuccess', function(ev){
            //$ionicView.beforeLeave
            // Don't allow the page to be dragged around
            $ionicSideMenuDelegate.canDragContent(false);
        });

        $scope.cancelOperation = function(){
            BiometricService.setBiometricLoginProtectionConfig(false);
            postBiometricLoginChecks();
        };

        $scope.useBiometricSensor = function(){
            //salvataggio dati
            BiometricService.setBiometricLoginProtectionConfig(true);
            window.plugins.touchid.save(CONFIG.biometricLoginKey, $stateParams.jusr+"__SEPARATOR__"+$stateParams.jpwd, function() {
                postBiometricLoginChecks();
            });
        };

        function postBiometricLoginChecks(){
            //primo accesso: forzo il cambio password
            var profile = getCurrentUser();
            if (profile.totaleCambiPassword == 0){
                $ionicPopup.alert({template: $translate.instant("alert-template-primo-accesso"),
                    title: $translate.instant("alert-title-cambio-password")}).then(function(){
                    $rootScope.goto("cambio-password");
                });
            }//verifica sottoscrizione provacy
            else if (profile.abilitatoPrivacy && !profile.privacyAccepted){
                $ionicPopup.alert({template: profile.flagPrivacyConsenso === null ? $translate.instant("alert-template-privacy-mancante") : $translate.instant("alert-template-privacy"),
                    title: $translate.instant("alert-title-attenzione")}).then(function(){
                    $rootScope.goto("privacy");
                });
            } else {
                $state.go("private-dashboard");
            }
        }

    })

    .controller('ProfileCtrl', function($scope, $http, $state, $ionicLoading, $ionicPopup, $ionicNavBarDelegate, $translate, ProfileService) {
        console.log("ProfileCtrl");

        trackView($state.current.name);

        function caricaIndirizziConsegna(){
            $ionicLoading.show();
            ProfileService.retrieveIndirizziConsegna().then(function (data) {
                $scope.indirizzi = data;

                $ionicLoading.hide();
            }, function() {
                $ionicPopup.alert({template: $translate.instant("alert-template-no-connessione"),
                    title: $translate.instant("alert-title-errore")});

                $ionicLoading.hide();
            });
        }

        caricaIndirizziConsegna();
    })
    
    .controller('NotificheCtrl', function($scope, $http, $state, $ionicLoading, $ionicPopup, NotificationsService) {
        trackView($state.current.name);

        $scope.elencoNotifiche = [];
        var recuperaNotifiche = function() {
            $ionicLoading.show();
            //carico la lista delle notifiche
            NotificationsService.listNuoveNotifiche().then(function (response) {
                $ionicLoading.hide();
                $scope.elencoNotifiche = response.value;
            });

        };

        recuperaNotifiche();

        $scope.leggiNotifica = function(notifica){
            $ionicPopup.alert({
                template: notifica.corpo,
                title: notifica.titolo
            }).then(function () {
                NotificationsService.markNewsAsRead(notifica).then(function(){
                    console.log("notifica letta!");
                    cordova.plugins.notification.badge.clear();
                    recuperaNotifiche();
                })
            });
        }
    })    

    .controller('NotificheCtrl', function($scope, $http, $state, $ionicLoading, $ionicPopup, NotificationsService) {
        trackView($state.current.name);

        $scope.elencoNotifiche = [];
        var recuperaNotifiche = function() {
            $ionicLoading.show();
            //carico la lista delle notifiche
            NotificationsService.listNuoveNotifiche().then(function (response) {
                $ionicLoading.hide();
                $scope.elencoNotifiche = response.value;
            });

        };

        recuperaNotifiche();

        $scope.leggiNotifica = function(notifica){
            $ionicPopup.alert({
                template: notifica.corpo,
                title: notifica.titolo
            }).then(function () {
                NotificationsService.markNewsAsRead(notifica).then(function(){
                    console.log("notifica letta!");
                    cordova.plugins.notification.badge.clear();
                    recuperaNotifiche();
                })
            });
        }
    })

    .controller('CambioMainCtrl', function($scope, $state, $stateParams, $rootScope, $http, $ionicPopup, $ionicLoading, $translate, ProfileService) {
        console.log("CambioMainCtrl");
        trackView($state.current.name);

        $scope.accountList = [];
        var codiceMain;

        $scope.selezionaMain = function(codice){
            $ionicLoading.show();
            // var loggedUser = getLoggedUser();

            ProfileService.listaMain(codice).then(
                function(response){
                    $ionicLoading.hide();

                    var data = response.data;

                    if (data.errorMessage !== null) {
                        $ionicPopup.alert({template: data.errorMessage,
                            title: $translate.instant("alert-title-attenzione")});
                    } else {
                        $scope.accountList = data.value;
                        codiceMain = codice;

                        if (data.value.length === 0) {

                            $ionicPopup.alert({template: $translate.instant("cambio-azienda-no-account-main-definiti"),
                                title: $translate.instant("alert-title-attenzione")});
                        }

                    }

                },
                function(error){
                    $ionicLoading.hide();
                });

        };

        $scope.impostaAccount = function(id){
            $ionicLoading.show();

            ProfileService.logAs(codiceMain,id).then(
                function (response) {
                $ionicLoading.hide();
                var data = response.data;

                if (data.authError !== null) {
                    $ionicPopup.alert({template: data.authError,
                        title: $translate.instant("alert-title-attenzione")});
                } else {

                    $rootScope.currentUser = data;
                    var loggedUser = getLoggedUser();

                    //svuoto lo cache locale
                    emptyStorage();
                    storeCurrentUser($rootScope.currentUser);
                    storeLoggedUser(loggedUser);

                    var profile = $rootScope.currentUser;
                    if (!profile.privacyAccepted){

                        $ionicPopup.alert({template: profile.flagPrivacyConsenso === null ? $translate.instant("alert-template-privacy-mancante") : $translate.instant("alert-template-privacy"),
                            title: $translate.instant("alert-title-attenzione")}).then(function(){
                            $rootScope.goto("privacy");
                        });
                    } else {
                        $state.go("private-dashboard");
                    }

                }
            },function(error){
                $ionicLoading.hide();
            });
        };

        if ($stateParams.main){

        }
    })

    .controller('CambioPasswordCtrl', function($scope, $rootScope, $state, $ionicLoading, $ionicSideMenuDelegate, $ionicPopup, $ionicViewService, $translate, $window, ProfileService) {
        console.log("CambioPasswordCtrl");

        trackView($state.current.name);

        var profile = getCurrentUser();
        if (profile.totaleCambiPassword == 0) {
            $ionicSideMenuDelegate.canDragContent(false);
            hideMenuButton();
        }

        $scope.iscrData = {vecchiaPwd: '', nuovaPwd:'', confermaPwd:'', errors: {}};

        $scope.cambioPassword = function(iscrData){
            $scope.iscrData.errors = {};

            if (iscrData.nuovaPwd != undefined && iscrData.nuovaPwd.length < CONFIG.MIN_PWD_LENGTH){
                $scope.iscrData.errors.nuovaPwd = "Inserire almeno " + CONFIG.MIN_PWD_LENGTH + " caratteri";
                return false;
            }

            $ionicLoading.show();

            ProfileService.changePassword(iscrData).then(function(response) {
                $ionicLoading.hide();

                if (response.errorMessage != null) {
                    $ionicPopup.alert({template: response.errorMessage,
                        title: $translate.instant("alert-title-errore")});
                }

                if (Object.size(response.data.value.errors) > 0) {
                    for (key in response.data.value.errors) {
                        $scope.iscrData.errors[key] = response.data.value.errors[key];
                    }
                }
                if (response.errorMessage == null && Object.size(response.data.value.errors) == 0) {

                    //window.localStorage.setItem("jpwd", iscrData.nuovaPwd);
                    //aggiorno il contatore password per riabilitare il menu
                    profile.totaleCambiPassword = 1;
                    store("profile", profile);
                    $rootScope.currentUser = profile;
                    if ($rootScope.loggedUser.totaleCambiPassword == 0){
                        $rootScope.loggedUser.totaleCambiPassword = profile.totaleCambiPassword;
                    }
                    $ionicPopup.alert({template: $translate.instant("alert-template-cambio-password"),
                        title: $translate.instant("alert-title-info")}).then( function(){

                        //contriollo privacy
                        if (!profile.privacyAccepted){
                            $ionicPopup.alert({template: $translate.instant("alert-template-privacy"),
                                title: $translate.instant("alert-title-attenzione")}).then(function(){
                                $rootScope.goto("privacy");
                            });
                        } else {
                            $ionicSideMenuDelegate.canDragContent(true);
                            showMenuButton();
                            $state.go("private-dashboard");
                            $ionicViewService.clearHistory();
                        }

                    });


                }

            }, function() {
                $ionicLoading.hide();
                $ionicPopup.alert({template: $translate.instant("alert-template-no-connessione"),
                    title: $translate.instant("alert-title-errore")});

            });
        }


    })

    .controller('ForgotPasswordCtrl', function($scope, $state, $stateParams, $ionicLoading, $ionicPopup, $translate, LoginService) {

        /**
         * accettazione del regolamento
         *
         */

        console.log("ForgotPasswordCtrl");
        trackView('password dimenticata');
        $scope.home = function(){
            console.log("ForgotPasswordCtrl - redirect to home");
            location.href = "#/login";
        };
        $scope.username = "";

        if ($state.current.name == "forgot-password-change-error") {
            //si e' verificato un errore nella richiesta
            $scope.errore = $stateParams.errorCode;
        }
        else if ($state.current.name == "forgot-password-change") {
            $scope.iscrData = {nuovaPwd: '', confermaPwd: '', errors: {}};
        }
        else if ($state.current.name == "forgot-password") {
            $scope.iscrData = {nuovaPwd: '', confermaPwd: '', errors: {}};
        }


        $scope.richiedi = function(email){
            console.log('ForgotPasswordCtrl - richiedi');
            $ionicLoading.show();

            LoginService.forgotPasswordRequest(email).then(function(response) {
                $ionicLoading.hide();

                if (response.data.errorMessage != null) {
                    $ionicPopup.alert({template: response.data.errorMessage,
                        title: $translate.instant("alert-title-errore")});

                } else {
                    $state.transitionTo("waitingmail-forgotpwd");
                }


            }, function() {
                $ionicLoading.hide();

                $ionicPopup.alert({template: $translate.instant("alert-template-connection-failure"),
                    title: $translate.instant("alert-title-errore")});

            });
        };

        $scope.conferma = function(iscrData){
            $scope.iscrData.errors = {};

            if (iscrData.nuovaPwd.length < CONFIG.MIN_PWD_LENGTH){
                $scope.iscrData.errors.password = $translate.instant("error-password-length").replace("{0}",CONFIG.MIN_PWD_LENGTH);
                return false;
            }

            $ionicLoading.show();

            LoginService.forgotPasswordConfirm($stateParams.token, iscrData).then(function(response) {
                $ionicLoading.hide();

                if (response.data.errorMessage != null) {
                    $ionicPopup.alert({
                        template: response.data.errorMessage,
                        title: $translate.instant("alert-title-errore")});
                }
                else if (Object.size(response.data.value.errors) > 0) {
                    for (key in response.data.value.errors) {
                        $scope.iscrData.errors[key] = response.data.value.errors[key];
                    }
                }
                else {
                    if (response.data.successMessage != null) {
                        $ionicPopup.alert({
                            template: response.data.successMessage,
                            title: $translate.instant("alert-title-info")
                        });
                    }

                    //aggiorno le impostazioni del login
                    // window.localStorage.setItem("jusr", $stateParams.username);
                    //window.localStorage.setItem("jpwd", iscrData.nuovaPwd);

                    $state.transitionTo("login", {jusr: $stateParams.username, jpwd: iscrData.nuovaPwd});
                }


            }, function() {
                $ionicLoading.hide();

                $ionicPopup.alert({template: $translate.instant("alert-template-connection-failure"),
                    title: $translate.instant("alert-title-errore")});

            });
        }

    })

    .controller('PrivacyCtrl', function($scope, $rootScope, $state, $ionicSideMenuDelegate, $ionicLoading, $ionicPopup, $sce, $translate, ProfileService) {
        console.log("PrivacyCtrl");
        trackView('privacy');

        $scope.$on('$stateChangeStart', function(ev){
            //$ionicView.afterEnter
           console.log('$stateChangeStart', ev);
            $ionicSideMenuDelegate.canDragContent(true);
            showMenuButton();
        });
        $scope.$on('$stateChangeSuccess', function(ev){
            //$ionicView.beforeLeave
           console.log('$stateChangeSuccess', ev);
            // Don't allow the page to be dragged around
            $ionicSideMenuDelegate.canDragContent(false);
            hideMenuButton();
        });


        ProfileService.getPrivacy().then(function(response){
            $scope.privacyNgBindHtml =  $sce.trustAsHtml(response.value);
        });

        $scope.data = {privacyFlag1: '', privacyFlag2: '', privacyFlag3: '', privacyFlag4: ''};


        $scope.confirm = function(data){
            $ionicLoading.show();

            ProfileService.changePrivacy(data).then(function(response){
                $ionicLoading.hide();
                if (response.data.errorMessage !== null) {
                    $ionicPopup.alert({
                        template: response.data.errorMessage,
                        title: $translate.instant("alert-title-errore")
                    });
                } else {
                    $state.go("private-dashboard");
                }

            }, function(error){
                $ionicLoading.hide();
            })

        }

    })

    .controller('CambioPrivacyCtrl', function($scope, $rootScope, $state, $ionicSideMenuDelegate, $ionicPopup, $sce, $translate, ProfileService) {
        console.log("CambioPrivacyCtrl");
        trackView('cambio-privacy');

        ProfileService.getPrivacy().then(function(response){
            $scope.privacyNgBindHtml =  $sce.trustAsHtml(response.value);
        });

        var profile = getCurrentUser();

        $scope.data = {
            privacyFlag1: profile.flagPrivacyConsenso,
            privacyFlag2: profile.flagPrivacyMarketing,
            privacyFlag3: profile.flagPrivacyProfilazione,
            privacyFlag4: profile.flagPrivacyTerzeParti};


        $scope.confirm = function(data){
            console.log(confirm, data);

            ProfileService.changePrivacy(data).then(function(response){

                if (response.data.errorMessage !== null) {
                    $ionicPopup.alert({
                        template: response.data.errorMessage,
                        title: $translate.instant("alert-title-errore")
                    });
                } else {
                    $state.go("private-dashboard");
                }

            })

        }

    });
