angular.module('app.controllers')

	.controller('DashboardPinCtrl', function ($scope, $state, $stateParams, $ionicPopup, $ionicLoading, $translate, CarteService, SecurityService) {
		console.log("PinUsaEGettaCtrl");


		var currentUser = getCurrentUser();

		//la carta deve già essere stata caricata
		var currentCard = CarteService.currentCard;

		console.log("tipo pin utente -> " + currentUser.tipoPin + ", carta -> " + currentCard.tipoPin, currentCard);

		var nonAbilitatoPersonalizzaPin = currentUser.dirigenteNew && (currentCard.pinAutista  || currentCard.pinUnico);
		var nonAbilitatoPinUsaEGetta = nonAbilitatoPersonalizzaPin || currentCard.pinUnico;

		$scope.nessunaAbilitazione = !currentUser.abilitatoVisualizzazionePin && nonAbilitatoPersonalizzaPin && nonAbilitatoPinUsaEGetta;

		currentCard.abilitatoVisualizzazionePin = currentUser.abilitatoVisualizzazionePin && !currentCard.pinAutista;
		currentCard.abilitatoVisualizzazionePinAutista = currentUser.abilitatoVisualizzazionePin && currentCard.pinAutista;

		currentCard.abilitatoPinTemporaneo = currentUser.abilitatoPinTemporaneo && !nonAbilitatoPinUsaEGetta && !currentCard.pinAutista;
		currentCard.abilitatoPinTemporaneoAutista = currentUser.abilitatoPinTemporaneo && !nonAbilitatoPinUsaEGetta && currentCard.pinAutista;

		currentCard.abilitatoPersonalizzaPin = currentUser.abilitatoPersonalizzaPin && !nonAbilitatoPersonalizzaPin;

		currentCard.abilitatoStoricoPin = (currentCard.abilitatoPersonalizzaPin || currentCard.abilitatoPinTemporaneo) && currentUser.abilitatoStoricoPin && !currentCard.pinAutista;
		currentCard.abilitatoStoricoPinAutista = currentCard.abilitatoPinTemporaneoAutista && currentUser.abilitatoStoricoPin;

		$scope.currentCard = currentCard;

		//delete cache results
		delete CACHE.autistiResults;


	})

	.controller('CambiaPinCtrl', function ($scope, $rootScope, $state, $stateParams, $ionicModal, $translate, $ionicLoading, $ionicPopup, ProfileService, CarteService, SecurityService) {
		console.log("CambiaPinCtrl");

		trackView($state.current.name);

		var currentCard = CarteService.currentCard;

		$scope.formData = {
			codiciSub: [],
			pan: currentCard.pan,
			codiciAutisti: [],
			nuovoCodiceAutista: '',
			tipoPin: 'random',
			periodoValiditaFlag: 'data',
			dataFineScadenzaCarta: false,
			t: currentCard.tipoPin
		};
		$scope.groups = {
			sub: {open: true},
			carte: {open: false},
			autista: {open: true},
			tipoPin: {open: false},
			limitazioni: {open: false},
			durata: {open: false},
			canale: {open: false}
		};

		var profile = getCurrentUser();

		$scope.profile = profile;
		$scope.errors = {};
		$scope.autoCompleteUrl = CONFIG.apiUrl + '/carte/search?token=' + profile.authToken + '&searchPhrase=';
		$scope.currentCard = currentCard;

		// $scope.onPanSelected = function($item) {
		// 	if (!$item) return;
		// 	$scope.formData.pan = $item.title;
		//
		// 	// se seleziono una carta resetto la selezione dei sub
		// 	$scope.formData.codiciSub = [];
		//
		// 	if ($scope.clienti) {
		// 		for (var i = 0; i < $scope.clienti.length; i++) {
		// 			$scope.clienti[i].selected = false;
		// 		}
		// 	}
		//
		// 	//$item.originalObject - the actual object which was selected
		//     //this.$parent - the control which caused the change, contains useful things like $index for use in ng-repeat.
		// };

		// $scope.onSubSelected = function () {
		// 	$scope.formData.codiciSub = [];
		//
		// 	if ($scope.clienti) {
		// 		for (var i = 0; i < $scope.clienti.length; i++) {
		// 			if ($scope.clienti[i].selected) {
		// 				$scope.formData.codiciSub.push($scope.clienti[i].codiceSub);
		// 				console.log("Selected sub " + $scope.clienti[i].codiceSub);
		// 			}
		// 		}
		// 	}
		//
		// 	// $scope.formData.pan = '';
		// 	// $scope.errors.pan = '';
		// 	$scope.$broadcast('angucomplete-alt:clearInput');
		// };

		// if (profile.profiloSingolaCarta) {
		// 	$scope.formData.pan = profile.pan;
		// }
		// else {
		// 	ProfileService.clienti().then(function (response) {
		// 		$scope.clienti = response.value;
		//
		// 		if ($scope.clienti) {
		// 			for (var i = 0; i < $scope.clienti.length; i++) {
		// 				$scope.clienti[i].numeroCarte = "-";
		// 				$scope.clienti[i].selected = false;
		//
		// 				setNumeroCarteBySub($scope.clienti[i]);
		// 			}
		// 		}
		//
		// 		function setNumeroCarteBySub(cliente) {
		// 			CarteService.numeroCarteBySub(cliente.codiceSub).then(function (numeroCarte) {
		// 				cliente.numeroCarte = numeroCarte;
		// 			})
		// 		}
		// 	});
		// }

		$scope.changeFineScadenza = function () {
			if ('true' === $scope.formData.dataFineScadenzaCarta) {
				$scope.formData.dataFineValidita = null
			}
		};

		$scope.digitsOnly = function(e) {
	        var char = e.which;
	        var charAllowed = char >= 48 && char <= 57 || char == 8 || char == 0;
	        if (!charAllowed) {
	        	e.preventDefault();
	        	return false;
	        }
	        return true;
		};

		function validate(form) {
			var errMsg = $translate.instant("alert-form-errors");
			$scope.errors = {};


			if (profile.pinAutista) {
				if ($scope.formData.codiciAutisti.length === 0) {
					$scope.errors.nuovoCodiceAutista = 'error.field.required';
					$scope.groups.autista.open = true;
					return errMsg;
				}
			}
			else
			{

                if (!profile.pinUnico) {
                    if ($scope.formData.codiciSub.length === 0 && $scope.formData.pan === '') {
                        $scope.errors.pan = 'error.field.required';
                        //$scope.groups.sub.open = true;
                        $scope.groups.carte.open = true;

                        return $translate.instant("cambia-pin-lbl-selezione-sub-o-carte");
                    }
                    if ($scope.formData.pan !== '' && $scope.formData.pan.length !== 19) {
                        $scope.errors.pan = 'error.field.invalid';
                        $scope.groups.carte.open = true;
                        return errMsg;
                    }
                } else {
                	//verifiche pin unico
                    if (profile.mainProfile) {

                        if ($scope.formData.codiciSub.length === 0 && $scope.formData.pan === '') {
                            $scope.errors.pan = 'error.field.required';
                            $scope.groups.sub.open = true;

                            return $translate.instant("cambia-pin-lbl-selezione-sub-o-carte");
                        }
                    }

                }
			}

			if (form.tipoPin === 'custom') {
				//controllo nuovoPIN e confermaNuovoPIN
				if (form.nuovoPIN === undefined) {
					$scope.errors.nuovoPIN = 'error.field.required';
					$scope.groups.tipoPin.open = true;
					return errMsg;
				}
				if (form.confermaNuovoPIN === undefined) {
					$scope.errors.confermaNuovoPIN = 'error.field.required';
					$scope.groups.tipoPin.open = true;
					return errMsg;
				}
				if (form.nuovoPIN !== undefined && form.nuovoPIN !== form.confermaNuovoPIN) {
					$scope.errors.confermaNuovoPIN = 'error.field.pin.confirm.mismatch';
					$scope.groups.tipoPin.open = true;
					return errMsg;
				}
			}

			if (form.periodoValiditaFlag === 'data') {
				var today = new Date().setHours(0,0,0,0); // tolgo ora e minuti

				if (form.dataInizioValidita && new Date(form.dataInizioValidita) < today) {
					$scope.errors.dataInizioValidita = 'error.field.required';
					$scope.groups.durata.open = true;
					return errMsg;
				}
				if (!form.dataFineScadenzaCarta) {
					if (form.dataFineValidita && form.dataInizioValidita && form.dataInizioValidita >= form.dataFineValidita) {
						$scope.errors.dataFineValidita = 'error.field.required';
						$scope.groups.durata.open = true;
						return errMsg;
					}
				}
			}
			else if (form.periodoValiditaFlag === 'minuti') {
				if (form.minutiValidita === undefined) {
					$scope.errors.minutiValidita = 'error.field.required';
					$scope.groups.durata.open = true;
					return errMsg;
				}
			}

			return '';
		}



		/**
		 * invia la richiesta al form
		 * @param formData
		 */
		$scope.inviaRichiesta = function (formData) {
			var errMsg = validate(formData);

			if (errMsg !== '') {
				$ionicPopup.alert({
					template: errMsg,
					title: $translate.instant("alert-title-attenzione")
				});
			}
			else if (profile.pinAutista)
				invioRichiestaCambioPinAutista(formData);
			else
				invioRichiestaCambioPin(formData);
		};

		function invioRichiestaCambioPin(formData) {
			$ionicLoading.show();

			formData.codiciSub = [];

			if ($scope.clienti) {
				for (var i = 0; i < $scope.clienti.length; i++) {
					if ($scope.clienti[i].selected) {
						formData.codiciSub.push($scope.clienti[i].codiceSub);
					}
				}
			}

            if (profile.subProfile && profile.pinUnico){
                formData.codiciSub.push(profile.codiceSub);
            }

			SecurityService.cambiaPin(formData).then(
				function (response) {
					$ionicLoading.hide();

					if (response.data.errorMessage !== null) {
						var msg = $translate.instant(response.data.errorMessage);

						if (response.data.tag !== null) {
							msg += " (" + response.data.tag + ")";
						}

						$ionicPopup.alert({
							template: msg,
							title: $translate.instant("alert-title-attenzione")
						});
					} else {
						store("cambio-pin-response", response.data.value);
						$state.go("cambia-pin-results")
					}
				},
				function (error) {
					$ionicLoading.hide();
					console.log("errore cambiaPin", error);

					// if (error.status === 401) {
					// 	// Unauthorized
					// 	$ionicPopup.alert({template: $translate.instant("dashboard-pin-unathorized"),
					// 		title: $translate.instant("alert-title-attenzione")});
					//
					// }

					$ionicPopup.alert({
						template: $translate.instant('generic.error'),
						title: $translate.instant("alert-title-attenzione")
					});
				}
			)
		}

		function invioRichiestaCambioPinAutista(formData) {
			$ionicLoading.show();

			formData.codiciSub = [];

			SecurityService.cambiaPinAutista(formData).then(
				function (response) {
					$ionicLoading.hide();

					console.log("cambio pin response: %o", response);

					if (response.data.errorMessage !== null) {
						var msg = $translate.instant(response.data.errorMessage);

						if (response.data.tag !== null) {
							msg += " (" + response.data.tag + ")";
						}

						$ionicPopup.alert({
							template: msg,
							title: $translate.instant("alert-title-attenzione")
						});
					} else {
						store("cambio-pin-response", response.data.value);
						$state.go("cambia-pin-results")
					}
				},
				function (error) {
					$ionicLoading.hide();
					console.log("errore cambiaPin", error);

					$ionicPopup.alert({
						template: $translate.instant('generic.error'),
						title: $translate.instant("alert-title-attenzione")
					});
				}
			)
		}



		$scope.aggiungiCarta = function (panCarta) {
			if (!panCarta || panCarta.length < 15) return;

			var index = $scope.formData.pans.indexOf(panCarta);
			if (index === -1) {
				$scope.formData.pans.push(panCarta);
				$scope.formData.nuovaCarta = "";
			}
		};

		$scope.rimuoviCarta = function (panCarta) {
			var index = $scope.formData.pans.indexOf(panCarta);
			if (index !== -1) {
				$scope.formData.pans.splice(index, 1);
			}
		};

		$scope.aggiungiCodiceAutista = function (codice) {
			if (codice === undefined || codice === '') return;

			while (codice.length < 5) {codice = "0" + codice;} // left pad a 5 caratteri

			var index = $scope.formData.codiciAutisti.indexOf(codice);
			if (index === -1) {
				$scope.formData.codiciAutisti.push(codice);
				$scope.formData.nuovoCodiceAutista = "";
				$scope.errors.nuovoCodiceAutista = undefined;
			}
		};

		$scope.rimuoviCodiceAutista = function (codice) {
			var index = $scope.formData.codiciAutisti.indexOf(codice);
			if (index !== -1) {
				$scope.formData.codiciAutisti.splice(index, 1);
			}
		}
	})

	.controller('PinUsaEGettaCtrl', function ($scope, $state, $stateParams, $ionicPopup, $ionicLoading, $translate, CarteService, SecurityService) {
		console.log("PinUsaEGettaCtrl");

		trackView($state.current.name);

		$scope.data = {pinTemporaneo: "", scadenza: "", codiceAutista: ""};

		var currentCard = CarteService.currentCard;

		var profile = getCurrentUser();
		$scope.profile = profile;

		$scope.richiediPinTemporaneo = function () {
			$ionicLoading.show();

			if (profile.pinAutista) {
				SecurityService.generaPinAutistaTemporaneo($scope.data.codiceAutista, currentCard.tipoPin)
					.then(
						function (response) {
							$ionicLoading.hide();

							if (null !== response.data.errorMessage && '' !== response.data.errorMessage) {
								$ionicPopup.alert({
									template: $translate.instant(response.data.errorMessage),
									title: $translate.instant("alert-title-attenzione")
								});
							} else {
								$scope.data.pinTemporaneo = response.data.value.pin;
								$scope.data.scadenza = response.data.value.dataScadenza;
							}
						},
						function (error) {
							console.log("generaPinAutistaTemporaneo", error);
							$ionicLoading.hide();
							$ionicPopup.alert({
								template: $translate.instant('error-service-not-available'),
								title: $translate.instant("alert-title-attenzione")
							});
						}
					);
			}
			else {
				SecurityService.generaPinTemporaneo(currentCard.pan)
					.then(
						function (response) {
							$ionicLoading.hide();

							if (null !== response.data.errorMessage && '' !== response.data.errorMessage) {
								$ionicPopup.alert({
									template: response.data.errorMessage,
									title: $translate.instant("alert-title-attenzione")
								});
							} else {
								$scope.data.pinTemporaneo = response.data.value.pin;
								$scope.data.scadenza = response.data.value.dataScadenza;
							}
						},
						function (error) {
                            $ionicLoading.hide();
							console.log("generaPinTemporaneo errore", error);
							$ionicPopup.alert({
								template: $translate.instant('error-service-not-available'),
								title: $translate.instant("alert-title-attenzione")
							});
						}
					);
			}
		}
	})

	.controller('StoricoPinCtrl', function ($scope, $rootScope, $state, $stateParams, $ionicModal, $translate, $ionicLoading, $ionicViewService, SecurityService, CarteService) {
		console.log("StoricoPinCtrl");

		trackView($state.current.name);

		var currentUser = getCurrentUser();
		var pageCount = 0;
		var currentCard = CarteService.currentCard;

		$scope.model = {sub: '', pan: currentCard.pan, tipoPin: currentCard.tipoPin};

		$scope.hasMoreData = false;
		$scope.showNoResultsFoundMessage = false;
		if (currentUser.subProfile) {
			$scope.model.sub = currentUser.codiceSub;
		}
		if (!currentUser.mainProfile && currentUser.clienti && currentUser.clienti.length == 1) {
			currentUser.clienti[0].codice;
		}

		// cerca($scope.model);

		// $ionicModal.fromTemplateUrl(
		// 	'templates/carte/ricerca.html',
		// 	{
		// 		scope: $scope,
		// 		animation: 'slide-in-up'
		// 	}
		// ).then(function (popover) {
		// 		$scope.modalSearch = popover;
        //         $rootScope.registerModal(popover);
		// 		if (!currentUser.profiloSingolaCarta && CACHE.storicoResults === undefined) {
		// 			$scope.showSearch();
		// 		} else if (currentUser.profiloSingolaCarta){
		// 			//utente con singola carta, effettuo ricerca immediata
        //             $scope.cerca($scope.model);
		// 		}
		// 	});

		// $scope.showSearch = function () {
        //     console.log(" security showSearch");
		// 	$scope.modalSearch.show();
		// };

		// $scope.filtri = obtainCachedFilter('filtriStoricoPin');

		(function (model) {
			// if (pageCount === 0) $ionicLoading.show();
			// currentModel = model;
			// if ($scope.modalSearch) {
			// 	$scope.modalSearch.hide();
			// 	//ricerca manuale
			// 	$scope.showNoResultsFoundMessage = true;
			// 	setCachedFilter('filtriStoricoPin', $scope, model);
			// }
			SecurityService.storicoPin(model).then(function (response) {
                $ionicLoading.hide();
				if (response.data) {
					$scope.results = response.data.content;
					pageCount = 1;
					$scope.hasMoreData = response.data.hasNext;
					CACHE.storicoResults = $scope.results;
					CACHE.pageCount = pageCount;
				}
			}, function(error){
                $ionicLoading.hide();
			});
		})($scope.model);

		// $scope.closeModal = function () {
		// 	$scope.modalSearch.hide();
        //     var view = $ionicViewService.getBackView();
        //     if (view) view.go();
		// };
	})

	.controller('CambiaPinResultsCtrl', function ($scope, $state, $stateParams, $ionicModal, $translate) {
		console.log("CambiaPinResultsCtrl");

		trackView($state.current.name);

		var profile = getCurrentUser();
		$scope.profile = profile;

		var result = retrieve("cambio-pin-response");

		//se è un messaggio da tradurre lo traduco
		if (result[0].error && result[0].error.indexOf('html.servizio') != -1) {
			result[0].error = $translate.instant(result[0].error);
		}

		$scope.results = result;
	})

	.controller('VisualizzaPinCtrl', function ($scope, $state, $stateParams, $ionicPopup, $ionicViewService, $translate, SecurityService) {
		console.log("VisualizzaPinCtrl");

		trackView($state.current.name);

		var currentUser = getCurrentUser();

		$scope.btnRichiestaCodiceDisabled = true;
		$scope.form = {password: ''};

		$scope.$on("onResume", function (event, data) {
			$scope.btnRichiestaCodiceDisabled = true;
			$scope.form = {password: ''};
			var view = $ionicViewService.getBackView();
			if (view) view.go();
		});

		if ($state.current.name === 'visualizza-pin') {
			var pan = $stateParams.pan;
			var codiceAutista = $stateParams.codiceAutista;

			if (currentUser.profiloSingolaCarta) {
				pan = currentUser.pan
			}

			console.log("pan", $stateParams.pan);
			console.log("codiceAutista", $stateParams.codiceAutista);

			//recupero il codice di controllo
			if (codiceAutista) {
				SecurityService.richiestaVisualizzaPinAutista(codiceAutista)
					.then(
						function (response) {
							CodiceControlloResponse(response);
						},
						function (error) {
							console.log(JSON.stringify(error));
						}
					);
			} else if (pan) {
				SecurityService.richiestaVisualizzaPin(pan)
					.then(
						function (response) {
							CodiceControlloResponse(response);
						},
						function (error) {
							console.log(JSON.stringify(error));
						}
					);
			}

			function CodiceControlloResponse(response) {
				if (null != response.errorMessage && '' != response.errorMessage) {
					$ionicPopup.alert({
						template: response.errorMessage,
						title: $translate.instant("alert-title-attenzione")
					});
				} else {
					$scope.codiceControllo = response.value;
					$scope.btnRichiestaCodiceDisabled = false;
				}
			}
		}


		$scope.confermaVisualizzaPin = function (formData) {
			var currentUser = getCurrentUser();
			var isPinAutista = currentUser.pinAutista;

			SecurityService.confermaVisualizzaPin(formData, $scope.codiceControllo, isPinAutista)
				.then(
					function (response) {
						console.log("######## visualizzaPin " + JSON.stringify(response));

						if (null != response.data.errorMessage && '' != response.data.errorMessage) {
							$ionicPopup.alert({
								template: response.data.errorMessage,
								title: $translate.instant("alert-title-attenzione")
							});
						} else {
							$ionicPopup.alert({
								template: "<h2><center>" + response.data.value.pin + "</center></h2>",
								title: ""
							}).then(function () {
								var view = $ionicViewService.getBackView();
								if (view) view.go();
							});
						}
					},
					function (error) {
						console.log(JSON.stringify(error));
					}
				)
		};
	});