angular.module('app.controllers')

    .controller('SetupCtrl', function($scope, $state, $stateParams, $ionicModal, AlertService, BiometricService) {
        console.log("SetupCtrl");
        trackView('setup');

        var profile = retrieve('profile');

        //push
        var pushCfg = {alias: '',
            pushEnabled: false, soundEnabled: false, vibrateEnabled: false, locationEnabled: false, quietTimeEnabled: false,
            startHour: '', startMinute: '', endHour: '', endMinute: '', tags: []};
        var paymentsCfg = {oneClickRequest: profile.oneClickRequest};

        $scope.pushCfg = pushCfg;
        $scope.platform = device.platform;

        //payments
        $scope.paymentsCfg = paymentsCfg;
        $scope.dpaymentCfg = {
            dpaydefault: false,
            cardNeverAsk: false,
            favoriteCard: ''
        };

        //fingerprint
        var touchIdPwd = "1234";
        //registrazione touchId/FaceId
        $scope.biometricLoginProtectionEnabled = false;
        //richiesta di protezione TouchId/FaceId
        $scope.biometricLoginProtectionConfig = BiometricService.getBiometricLoginProtectionConfig();
        $scope.formData = { biometricCodesProtectionEnabled: BiometricService.getBiometricCodesProtectionConfig() };
        $scope.hasFingerprint = false;

        init();

        function init() {

            $scope.dpaymentCfg.dpaydefault = CONFIG.DPAY_DEFAULT === retrieve(PROFILEKEYS.FAVORITE_PAYMENTS_TYPE);
            $scope.dpaymentCfg.cardNeverAsk = retrieve(PROFILEKEYS.FAVORITE_PAYMENTS_CARD_NEVER_ASK_FLAG);
            $scope.dpaymentCfg.favoriteCard = retrieve(PROFILEKEYS.FAVORITE_PAYMENTS_CARD);

            //alias: codice cliente
            pushMeApp.getAlias().then(function(response) {
                var username = profile.email;
                if(username != response.alias ) {
                    pushMeApp.setAlias(username).then( function() {
                        setAlias(username);
                    });
                } else {
                    setAlias(username);
                }
            });

            pushMeApp.getSettings().then(function (response) {
                console.log("pushMeApp.getSettings " + JSON.stringify(response));
                $scope.pushCfg.pushEnabled = response.enabled;
                $scope.pushCfg.quietTimeEnabled = response.quietTimeEnabled;
                if (response.quietTimeStart) {
                    var startTime = response.quietTimeStart.split(":");
                    $scope.pushCfg.startHour = startTime[0];
                    $scope.pushCfg.startMinute = startTime[1];
                }
                if (response.quietTimeEnd) {
                    var endTime = response.quietTimeEnd.split(":");
                    $scope.pushCfg.endHour = endTime[0];
                    $scope.pushCfg.endMinute = endTime[1];
                }
                if (response.tags) {
                    $scope.pushCfg.tags = response.tags.split(",");
                    setTags($scope.pushCfg.tags);
                }

            });


            //verifico la presenza della biometria
            if (window.plugins && window.plugins.touchid) {
                window.plugins.touchid.isAvailable(function() {
                    $scope.hasFingerprint = true;
                }, function(msg) {
                    $scope.hasFingerprint = false;
                    console.log("Fingerprint not available");
                });
            }

            if (window.plugins && window.plugins.touchid) {
                window.plugins.touchid.has(CONFIG.biometricLoginKey, function() {
                    $scope.biometricLoginProtectionEnabled = true;
                }, function() {
                    $scope.biometricLoginProtectionEnabled = false;
                });
            }
	    
            //todo: impostare il permesso battery optimization
            // if (window.device.platform.toLowerCase() === "android") {
            //     //verifica Battery Optiomization (background task)
            //     cordova.plugins.DozeOptimize.IsIgnoringBatteryOptimizations(function (responce) {
            //         console.log("IsIgnoringBatteryOptimizations: " + responce);
            //         if (responce == "false") {
            //             cordova.plugins.DozeOptimize.RequestOptimizations(function (responce) {
            //                 console.log(responce);
            //                 cordova.plugins.backgroundMode.enable();
            //             }, function (error) {
            //                 console.error("BatteryOptimizations Request Error" + error);
            //             });
            //         }
            //         else {
            //             console.log("Application already Ignoring Battery Optimizations");
            //             cordova.plugins.backgroundMode.enable();
            //         }
            //     }, function (error) {
            //         console.error("IsIgnoringBatteryOptimizations Error" + error);
            //     });
            // }	    
        };

        function setAlias(alias) {
            $scope.pushCfg.alias = alias;
        }

        $scope.setPushEnabled = function(isEnabled){
            if(isEnabled) {
                pushMeApp.setUserNotificationsEnabled(true);
            } else {
                pushMeApp.setUserNotificationsEnabled(false);
            }
        };

        $scope.setQuietTimeEnabled = function(isEnabled){
            pushMeApp.setQuietTimeEnabled(isEnabled);
        };

        $scope.setQuietTime = function(cfg) {
            pushMeApp.setQuietTime(parseInt(cfg.startHour), parseInt(cfg.startMinute), parseInt(cfg.endHour), parseInt(cfg.endMinute)).then(function(res) {
                console.log("Set quiet time from JS")
            })
        };

        // $scope.setQuietTime = function(cfg) {
        //   UAirship.setQuietTime(parseInt(cfg.startHour), parseInt(cfg.startMinute), parseInt(cfg.endHour), parseInt(cfg.endMinute), function() {
        //     console.log("Set quiet time from JS")
        //   })
        // };

        $scope.setTag = function (tag, enabled){
            if (enabled) addTag(tag)
            else removeTag(tag);
        };

        function addTag(tag){
            console.log("adding tag " + tag);

            if($scope.pushCfg.tags.indexOf(tag) == -1) {
                console.log("Valid tag: " + tag)
                $scope.pushCfg.tags = $scope.pushCfg.tags.concat([tag])

                pushMeApp.setTags($scope.pushCfg.tags).then(function() {
                    setTags($scope.pushCfg.tags);
                })
            }

        };

        function removeTag (tag){

            console.log("Removing tag: " + tag)
            $scope.pushCfg.tags.splice($scope.pushCfg.tags.indexOf(tag), 1)
            pushMeApp.setTags($scope.pushCfg.tags, function(){
                setTags($scope.pushCfg.tags);
            })

        };

        function setTags(tags){
            $scope.pushCfg.newsEnabled = (tags.indexOf('news') != -1);
            $scope.pushCfg.promoNazionaliEnabled = (tags.indexOf('promo_nazionali') != -1);

            //if($scope.pushCfg.promoLocaliEnabled ) {
            //    PushNotification.enableLocation();
            //} else {
            //    PushNotification.disableLocation();
            //}
        }

        $scope.setDefaultPaymentDpay = function(flag){

            if (flag){
                store(PROFILEKEYS.FAVORITE_PAYMENTS_TYPE, CONFIG.DPAY_DEFAULT);
                $scope.dpaymentCfg.dpaydefault = true;
            } else {
                window.localStorage.removeItem(PROFILEKEYS.FAVORITE_PAYMENTS_TYPE);
                $scope.dpaymentCfg.dpaydefault = false;
            }
        };

        $scope.setNeverAsk = function(flag){

            if (flag){
                store(PROFILEKEYS.FAVORITE_PAYMENTS_CARD_NEVER_ASK_FLAG, flag);
                $scope.dpaymentCfg.neverAskFlag = true;
            } else {
                window.localStorage.removeItem(PROFILEKEYS.FAVORITE_PAYMENTS_CARD_NEVER_ASK_FLAG);
                $scope.dpaymentCfg.neverAskFlag = false;
            }
        };

        $scope.removeFavoriteCard = function(){
            window.localStorage.removeItem(PROFILEKEYS.FAVORITE_PAYMENTS_CARD);
            $scope.dpaymentCfg.favoriteCard = '';
            $scope.setNeverAsk(false);
        };

        $scope.setBiometricCodesProtection = function(){

            window.plugins.touchid.verify(CONFIG.biometricLoginKey, "Verifica identit�", function(password) {
                BiometricService.setBiometricCodesProtectionConfig($scope.formData.biometricCodesProtectionEnabled);
                // window.plugins.touchid.delete(CONFIG.biometricLoginKey, function() {
                //     $scope.formData.biometricCodesProtectionEnabled = false;
                // });
            }, function(){
                //ripristino il flag
                $scope.formData.biometricCodesProtectionEnabled = !$scope.formData.biometricCodesProtectionEnabled
            });

        };

        $scope.resetBiometricLogin = function(){
            if (BiometricService.getBiometricLoginProtectionConfig() === false){
                BiometricService.removeBiometricLoginProtectionConfig();
                BiometricService.removeBiometricCodesProtectionConfig();
                // $scope.$apply(function (scope){

                    console.log("biometricLoginProtectionConfig impostato a null!!");

                    $scope.biometricLoginProtectionConfig = null;
                // })
                return;
            }

            window.plugins.touchid.verify(CONFIG.biometricLoginKey, "Verifica identit�", function(password) {
                window.plugins.touchid.delete(CONFIG.biometricLoginKey, function() {
                    $scope.$apply(function (scope){
                        scope.biometricLoginProtectionEnabled = false;
                    })
                });
                BiometricService.removeBiometricLoginProtectionConfig();
                BiometricService.removeBiometricCodesProtectionConfig();

                $scope.$apply(function (scope){

                    console.log("biometricLoginProtectionConfig impostato a null!!");

                    scope.biometricLoginProtectionConfig = null;
                })
                }, function(){

            });
        }

        $scope.isBiometricLoginProtectionNotEnabled = function(){
            return $scope.biometricLoginProtectionConfig !== null && !$scope.biometricLoginProtectionEnabled;
        }

        $scope.isBiometricLoginProtectionDefined = function(){
            return $scope.biometricLoginProtectionConfig !== null
        }

    });

