angular.module('app.controllers')

    .controller('TransazioniCtrl', function($scope, $rootScope, $state, $stateParams, $ionicModal, $ionicViewService, TransazioniService) {
        console.log("TransazioniCtrl");
        trackView('ricerca transazioni');

        var currentUser = getCurrentUser();
        var pageCount = 0;
        var currentModel;   //memorizza il modello corrente per la ricerca paginata

        $scope.model = {sub: '', pan: '', periodo: 'W'};
        $scope.hasMoreData = false;
        $scope.showNoResultsFoundMessage = false || currentUser.profiloSingolaCarta;  // i driver non hanno la ricerca
        if (currentUser.profiloSingolaCarta) {
            $scope.model.pan = currentUser.pan;
        }
        if (currentUser.subProfile){
            $scope.model.sub = currentUser.codiceSub;
        }
        if (!currentUser.mainProfile && currentUser.clienti && currentUser.clienti.length == 1){
            $scope.model.sub = currentUser.clienti[0].codice;
        }

        $ionicModal.fromTemplateUrl('templates/transazioni/ricerca.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (popover) {
            $scope.modalSearch = popover;
            $rootScope.registerModal(popover);
            // $stateParams.pan provengo dal dettaglio carta
            if (CACHE.results === undefined && $stateParams.pan === undefined){
                $scope.showSearch();
            }
        });

        $scope.showSearch = function () {
            console.log(" transazioni showSearch");
            $scope.modalSearch.show();
        };

        $scope.filtri = obtainCachedFilter('filtriTransazioni');

        $scope.cerca = function(model){
            currentModel = model;
            if ($scope.modalSearch) {
                $scope.modalSearch.hide();
                //ricerca manuale
                $scope.showNoResultsFoundMessage = true;
                setCachedFilter('filtriTransazioni', $scope, model);
            }
            TransazioniService.ricerca(model).then(function(response) {
                if (response.data) {
                    $scope.results = response.data.content;
                    pageCount = 1;
                    $scope.hasMoreData = response.data.hasNext;
                    CACHE.results = $scope.results;
                    CACHE.pageCount = pageCount;
                }
            });
        };

        $scope.closeModal = function(){
            $scope.modalSearch.hide();
            var view = $ionicViewService.getBackView();
            if (view) view.go();
        };

        $scope.loadMore = function() {
            if ($scope.hasMoreData) {

                TransazioniService.ricerca(currentModel, pageCount).then(function (response) {
                    if (response.data) {
                        for (var i = 0; i < response.data.content.length; i++) {
                            $scope.results.push(response.data.content[i]);
                        }

                        pageCount++;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.hasMoreData = response.data.hasNext;
                        CACHE.results = $scope.results;
                        CACHE.pageCount = pageCount;
                    }
                });
            }
        };

        $scope.dettaglio = function(numeroTransazione){
            var transazione;
            for (var i = 0; i < $scope.results.length; i++) {
                if ($scope.results[i].numeroTransazione == numeroTransazione){
                    transazione = $scope.results[i];
                    i = $scope.results.length;
                }
            }
            store('dettaglio-transazione', transazione);
            $state.transitionTo('dettaglio-transazione');
        };

        if ($stateParams.pan){
            // provengo dal dettaglio carta
            currentModel = {sub: '', pan: $stateParams.pan, periodo: ''};
            TransazioniService.ricerca(currentModel).then(function(response) {
                if (response.data) {
                    $scope.results = response.data.content;
                    pageCount = 1;
                    console.log("more data available? " + response.data.hasNext);
                    $scope.hasMoreData = response.data.hasNext;
                    CACHE['results'] = $scope.results;
                    CACHE['pageCount'] = pageCount;
                    $scope.showNoResultsFoundMessage = true;
                }
            });
        } else {
            if ($scope.$navDirection == "back"){
                $scope.results = CACHE.results;
                pageCount = CACHE.pageCount;
            } else {
                //ricerca di default
                // $scope.cerca($scope.model);
            }
        }

    })

    .controller('DettaglioTransazioneCtrl', function($scope) {
        console.log("DettaglioTransazioneCtrl");

        trackView('dettaglio transazione');

        $scope.item = retrieve('dettaglio-transazione');
    })
