angular.module('app.controllers', [])

    .controller('MainCtrl', function () {
        console.log("MainCtrl");
   })

    .controller('MenuCtrl', function($scope, $state, $rootScope, $ionicSideMenuDelegate, $ionicViewService, $ionicLoading, $ionicPopup, $ionicActionSheet, $translate, $timeout, LoginService, BiometricService) {
        console.log("MenuCtrl");

        $scope.isTablet = isTablet();
        var currentUser = getLoggedUser();
        if (currentUser) {
            $rootScope.currentUser = currentUser;
            $rootScope.loggedUser = currentUser;
        }

        $scope.$on('userLoggedIn', function(event, args) {
            currentUser = args.profile;
            $scope.currentUser = currentUser;
            $scope.loggedUser = currentUser;
            $rootScope.currentUser = currentUser;
            $rootScope.loggedUser = currentUser;
        });

        $scope.$on('userLoggedOut', function(event, args) {
            currentUser = null;
            $scope.currentUser = currentUser;
            $scope.loggedUser = currentUser;
            $rootScope.currentUser = currentUser;
            $rootScope.loggedUser = currentUser;
        });

        $scope.showMenu = function () {
            //abilitato solo se non loggato e se non devo cambiare password
            if (currentUser && (currentUser.authToken == null || currentUser.totaleCambiPassword > 0))
                $ionicSideMenuDelegate.toggleLeft();
        };

        $scope.toggleLeft = function () {
            if ($ionicSideMenuDelegate.isOpenRight())
                $ionicSideMenuDelegate.toggleRight();
        };

        $scope.toggleRight = function () {
            if ($ionicSideMenuDelegate.isOpenLeft())
                $ionicSideMenuDelegate.toggleLeft();
        };

        $rootScope.openMenu = function(elClass){
            var dataMenuCarte = document.getElementsByClassName(elClass);

            //chiudo tutti i menu
            var menuItems = document.getElementsByClassName('data-item');
            for (var i=0; i<menuItems.length; i++){
                if (!menuItems[i].classList.contains(elClass)) {
                    menuItems[i].classList.remove('ng-open');
                    menuItems[i].classList.add('ng-close');
                }
            }

            if (dataMenuCarte[0].classList.contains('ng-close')) {
                dataMenuCarte[0].classList.remove('ng-close');
                dataMenuCarte[0].classList.add('ng-open');
            } else {
                dataMenuCarte[0].classList.remove('ng-open');
                dataMenuCarte[0].classList.add('ng-close');
            }
        };

        $rootScope.login = function (loginData) {
            $ionicLoading.show();

            LoginService.login(loginData.username, loginData.password)
                .then(function(result) {

                    $ionicLoading.hide();
                    var profile = result.data;

                    // fixProfiloDaVersione2aVersione3(profile);

                    if (profile.authError != null) {
                        $ionicPopup.alert({template: profile.authError, title: $translate.instant("alert-title-attenzione")});
                    }
                    else
                    {
                        if (loginData.username) store("jusr", loginData.username);
                        // if (loginData.password) store("jpwd", loginData.password);

                        storeCurrentUser(profile);
                        storeLoggedUser(profile);
                        $rootScope.currentUser = profile;
                        $rootScope.loggedUser = profile;

                        retrieveProfiledStoredData(profile);
                        $rootScope.$broadcast('userLoggedIn', { profile: profile });


                        //notifico l'alias: codice cliente
                        pushMeApp.getAlias().then(function(response) {
                            var username = loginData.username;
                            if(username != response.alias ) {
                                pushMeApp.setAlias(username).then( function() {
                                });
                            }
                        });


                        //richiesta touch-id
                        if (window.plugins && window.plugins.touchid) {
                            //mostro la schermata per il riconoscimento biometrico, se non l'ho mai chiesto prima
                            window.plugins.touchid.isAvailable(function() {

                                BiometricService.setBiometricCodesProtectionConfig(true);
                                //verifico che sia stato attivato
                                var isBiometricLoginEnabled = BiometricService.getBiometricLoginProtectionConfig();
                                if (null === isBiometricLoginEnabled){
                                    $rootScope.gotoBiometricLoginProtection(loginData.username, loginData.password);
                                } else {
                                    postLoginChecks();
                                }

                            }, function(msg) {
                                console.log("Fingerprint not available");
                                postLoginChecks();
                            });
                        }

                        function postLoginChecks(){
                            var profile = getCurrentUser();
                            //primo accesso: forzo il cambio password
                            if (profile.totaleCambiPassword == 0){
                                $ionicPopup.alert({template: $translate.instant("alert-template-primo-accesso"),
                                    title: $translate.instant("alert-title-cambio-password")}).then(function(){
                                    $rootScope.goto("cambio-password");
                                });
                            }//verifica sottoscrizione provacy
                            else if (profile.abilitatoPrivacy && !profile.privacyAccepted){
                                $ionicPopup.alert({template: profile.flagPrivacyConsenso === null ? $translate.instant("alert-template-privacy-mancante") : $translate.instant("alert-template-privacy"),
                                    title: $translate.instant("alert-title-attenzione")}).then(function(){
                                    $rootScope.goto("privacy");
                                });
                            } else {
                                $state.go("private-dashboard");
                            }
                        }
                    }
                }, function(error) {
                    $scope.isNotLoggingIn = true;
                    $ionicLoading.hide();
                    console.log("ERRORE LOGIN " + JSON.stringify(error));
                    $ionicPopup.alert({template: $translate.instant("alert-template-no-connessione"),
                        title: $translate.instant("alert-title-errore")});

                });
        };

        function _selectAction(ricercaPath, functionSearchPath){
            var currentUser = $rootScope.currentUser;
            if (currentUser.profiloSingolaCarta){
                //salto la selezione del pan
                functionSearchPath(currentUser.pan);
            } else if ( !currentUser.profiloSingolaCarta && currentUser.carteTotali === 1 ){
                //salto la selezione del pan
                functionSearchPath();
            } else if ( !currentUser.profiloSingolaCarta && currentUser.carteTotali > 1 ){
                $rootScope.goto(ricercaPath);
            } else {
                console.warn(ricercaPath + ": operazione non permessa", currentUser);
            }
        }

        function _selectActionForCarteValide(ricercaPath, functionSearchPath){
            var currentUser = $rootScope.currentUser;
            if (currentUser.profiloSingolaCarta){
                //salto la selezione del pan
                functionSearchPath(currentUser.pan);
            } else if ( !currentUser.profiloSingolaCarta && currentUser.carteValide === 1 ){
                //salto la selezione del pan
                functionSearchPath();
            } else if ( !currentUser.profiloSingolaCarta && currentUser.carteValide > 1 ){
                $rootScope.goto(ricercaPath);
            } else {
                console.warn(ricercaPath + ": operazione non permessa", currentUser);
            }
        }

        $rootScope.ricercaCarte = function(){

            var currentUser = $rootScope.currentUser;
            if (currentUser.profiloSingolaCarta){
                //salto la selezione del pan
                $rootScope.goto('dettaglio-carta');
            } else if ( !currentUser.profiloSingolaCarta && currentUser.carteTotali === 1 ){
                //salto la selezione del pan
                $rootScope.gotoSingolaCarta();
            } else if ( !currentUser.profiloSingolaCarta && currentUser.carteTotali > 1 ){
                $rootScope.goto('ricerca-carte');
            } else {
                console.warn("ricercaCarte: operazione non permessa", currentUser);
            }

        };

        $rootScope.bloccoCarta = function(){
            _selectAction('ricerca-blocco-carte', $rootScope.blocca);
        };

        $rootScope.codiciPagamento = function(){
            _selectActionForCarteValide('ricerca-generacodice-carte', $rootScope.generaCodice);
        };

        $rootScope.storicoSblocchiDPay = function(){
            _selectAction('ricerca-storico-sblocchi-dpay', $rootScope.storicoSblocchiDPayment);
        };

        $rootScope.storicoCodiciPagamento = function(){
            _selectAction('ricerca-storicocodici-carte', $rootScope.storicoCodici);
        };

        $rootScope.faiRifornimento = function(){
            var currentUser = $rootScope.currentUser;
            var favoriteCardPan = retrieve(PROFILEKEYS.FAVORITE_PAYMENTS_CARD);
            if (currentUser.profiloSingolaCarta){
                //salto la selezione del pan
                $rootScope.sceltaPuntoVendita(currentUser.pan);
            } else if (favoriteCardPan){
                //salto la selezione del pan
                $rootScope.sceltaPuntoVendita(favoriteCardPan);
            } else if (!currentUser.profiloSingolaCarta && currentUser.carteValide === 1){
                //salto la selezione del pan
                $rootScope.sceltaPuntoVendita();
            } else if (!currentUser.profiloSingolaCarta && currentUser.carteValide > 1){
                var neverAskFavorite = retrieve(PROFILEKEYS.FAVORITE_PAYMENTS_CARD_NEVER_ASK_FLAG) || false;
                $rootScope.goto('ricerca-dpayment', { askFavorite: !neverAskFavorite, domain: PROFILEKEYS.FAVORITE_PAYMENTS_CARD });
            } else {
                console.warn("faiRifornimento: operazione non permessa", currentUser);
            }
        };

        $rootScope.dashboardPin = function(){

            console.log("dashboardPin")

            var currentUser = $rootScope.currentUser;
            if (currentUser.pinAutista && !currentUser.profiloSingolaCarta){
                $rootScope.goto("ricerca-dashboard-pin-carta");
            }
            else if (!currentUser.pinAutista && !currentUser.profiloSingolaCarta &&  currentUser.carteValide > 1){
                $rootScope.goto("ricerca-dashboard-pin-carta");
            }
            else if (!currentUser.pinAutista && !currentUser.profiloSingolaCarta && currentUser.carteValide === 1){
                $rootScope.gotoDashboardPin();
            }
            else if (currentUser.profiloSingolaCarta){
                $rootScope.gotoDashboardPin(currentUser.pan);
            }
            else {
                console.warn("pinTemporaneo: operazione non permessa", currentUser);
            }


        };

        $rootScope.gotoBiometricLoginProtection = function(jusr, jpwd){

            $ionicViewService.clearHistory();
            $ionicViewService.nextViewOptions({ disableBack: true, disableAnimate: true, historyRoot: false });

            $state.go('login-biometric-setup', { jusr: jusr, jpwd: jpwd });
        };

    })

    .controller('DashboardCtrl', function($scope, $rootScope, $state, $stateParams, $translate, $ionicViewService, BiometricService) {
        CONFIG.rootView = $ionicViewService.getCurrentView().viewId;

        $rootScope.currentUser = retrieve('profile');

        // var language = window.navigator.userLanguage || window.navigator.language;
        // tmhDynamicLocale.set(language);
        trackView($state.current.name);

        //reetto la ricerca
        delete CACHE.results;
        delete CACHE.storicoResults;
        delete CACHE.results_carta;
        delete CACHE.pageCount;

    })

    .controller('MenuContentCtrl', function($scope, $state, $rootScope, $ionicPopup, $translate, $window, $ionicViewService, $http, CarteService) {
        console.log("MenuContentCtrl");

        // //$scope.currentUser = getLoggedUser();
        $rootScope.logout = function() {
            $ionicViewService.clearHistory();
            emptyStorage();
            $state.transitionTo("public-dashboard");
        };

        $rootScope.partialLogout = function() {
            $ionicViewService.clearHistory();
            emptyStorage(true);
            $state.transitionTo("public-dashboard");
        };

        $rootScope.openPdfFile = function(pdfFile) {
            if (pdfFile) {
                try {
                    if (window.device.platform.toLowerCase() == "ios") {
                        $window.open("../www/pdf/" + pdfFile, "_blank", 'location=no,hidden=no,enableViewportScale=yes');
                    }
                    else {
                        var indexUrl = window.location.href;
                        var workingFolder = indexUrl.substring(0, indexUrl.indexOf("html"));
                        var filePath = workingFolder.replace("http://", "file://") + "www/pdf/" + pdfFile;

                        $window.requestFileSystem(LocalFileSystem.TEMPORARY, 0, function(fs){
                            fs.root.getFile("temp.pdf", {create: true, exclusive: false},
                                function(entry){
                                    var fileTransfer = new FileTransfer();

                                    fileTransfer.download(
                                        filePath,
                                        entry.toURL(),
                                        function(entry) {
                                            $window.open(entry.toURL(), "_system", 'location=no,hidden=no,enableViewportScale=yes');
                                        },
                                        function(error) {
                                            console.error(error);
                                        },
                                        false,
                                        null
                                    );
                                }, function(){
                                    alert("file create error");
                                });
                        }, null);
                    }
                } catch (ex) {
                    $window.open("../www/pdf/" + pdfFile, "_blank", 'location=no,enableViewportScale=yes');
                }
            }
        };

        //va ad una view impostando la dashboard come rootView
        $rootScope.goto = function(path, options){

            options = options || {};
            console.log("transitionTo " + path, options);
            //reetto la ricerca
            delete CACHE.results;
            delete CACHE.storicoResults;
            delete CACHE.results_carta;
            delete CACHE.pageCount;

            var currentView = $ionicViewService._getViewById(CONFIG.rootView);
            if (currentView) $rootScope.$viewHistory.currentView = currentView;
            $ionicViewService.clearHistory();

            $state.transitionTo(path, options);
        };

        // va ad una view recuperando la prima carta valida dalla lista carte
        $rootScope.gotoSingolaCarta = function( options){

            CarteService.ricerca( { sub: "" } ).then(
                function(response){
                    if (response.data && response.data.content.length > 0) {
                        var item = response.data.content[0];
                        CarteService.currentCard = item;
                        $rootScope.goto('dettaglio-carta', options);
                    } else {
                        //todo: mostrare avviso
                        console.log("gotoSingolaCarta: nessuna carta recuperata!")
                    }
                }
            )

        };

        /**
         * va al dettaglio di una carta
         * @param path pagina di dettaglio
         * @param pan il pan carta o se non presente, la prima dell'elenco (per main/sub con una sola carta)
         * @private
         */
        _gotoDettaglioCarta = function(path, pan, options){

            console.log("_gotoDettaglioCarta path " + path + " pan " + pan, options );

            var codiceAutista = (options && options.codiceAutista) ? options.codiceAutista : false;
            var allCards = (options && options.allCards) ? options.allCards : false;


            if (pan) {

                //ho la carta in cache, evito la ricerca
                if (CarteService.currentCard && CarteService.currentCard.pan === pan){
                    $state.transitionTo(path, {pan: pan});
                    return;
                }


                // $state.transitionTo(path, { pan: pan } );
                CarteService.ricerca( { pan: pan } ).then(
                    function(response){
                        if (response.data) {
                            //recupero la prima carta attiva
                            // console.log("_gotoDettaglioCarta", response.data.content);
                            for (var i=0; i<response.data.content.length; i++) {
                                var item = response.data.content[i];
                                CarteService.currentCard = item;

                                //ciclare sulla prima carta attiva
                                if (!item.bloccata){

                                    console.log("_gotoDettaglioCarta", item);
                                    $state.transitionTo(path, {pan: item.pan});
                                    return;
                                }

                                //se present il flag all cards allora va bene qualsiasi statp
                                if (allCards){
                                    // store('dettaglio-carta', item);

                                    $state.transitionTo(path, {pan: item.pan});
                                    return;
                                }
                            }
                            $ionicPopup.alert({template: $translate.instant("alert-template-nessuna-carta-attiva"), title: $translate.instant("alert-title-attenzione")});
                            console.warn("_gotoDettaglioCarta", "nessuna carta attiva recuperata")
                        }
                    }
                )

            } else if (codiceAutista) {
                $state.transitionTo(path, { codiceAutista: codiceAutista } );
            } else {
                CarteService.ricerca( { sub: "" } ).then(
                    function(response){
                        if (response.data) {
                            //recupero la prima carta attiva
                            // console.log("_gotoDettaglioCarta", response.data.content);
                            for (var i=0; i<response.data.content.length; i++) {
                                var item = response.data.content[i];
                                CarteService.currentCard = item;

                                //ciclare sulla prima carta attiva
                                if (!item.bloccata){
                                    // store('dettaglio-carta', item);
                                    console.log("_gotoDettaglioCarta", item);
                                    $state.transitionTo(path, {pan: item.pan});
                                    return;
                                }

                                //se present il flag all cards allora va bene qualsiasi statp
                                if (allCards){
                                    // store('dettaglio-carta', item);
                                    $state.transitionTo(path, {pan: item.pan});
                                    return;
                                }
                            }
                            $ionicPopup.alert({template: $translate.instant("alert-template-nessuna-carta-attiva"), title: $translate.instant("alert-title-attenzione")});
                            console.warn("_gotoDettaglioCarta", "nessuna carta attiva recuperata")
                        }
                    }
                )
            }
        };

        $rootScope.blocca = function(pan){
            _gotoDettaglioCarta('blocco-carta', pan);
        };

        $rootScope.sceltaPuntoVendita = function(pan){
            _gotoDettaglioCarta('dpayment-punto-vendita', pan);
        };

        $rootScope.generaCodice = function(pan){
            _gotoDettaglioCarta('generacodice-carte', pan);
        };

        $rootScope.storicoCodici = function(pan){
            _gotoDettaglioCarta('storicocodici-carte', pan, {allCards: true});
        };

        $rootScope.storicoSblocchiDPayment = function(pan){
            _gotoDettaglioCarta('storicocodici-sblocchi-dpay', pan, {allCards: true});
        };

        $rootScope.generaPinTemporaneo = function(pan){
            _gotoDettaglioCarta('pin-temporaneo-carta', pan);
        };

        $rootScope.visualizzaPin = function(pan){
            _gotoDettaglioCarta('visualizza-pin', pan);
        };

        $rootScope.visualizzaPinAutista = function(pan, codicaAutista){
            _gotoDettaglioCarta('visualizza-pin', pan, {codicaAutista: codicaAutista});
        };

        $rootScope.gotoDashboardPin = function(pan){
            _gotoDettaglioCarta('dashboard-pin', pan);
        };

        $rootScope.isItemActive = function(key1, key2){
            if (key1 && key2){
                return $state.current.name === key1 || $state.current.name === key2;
            } else if (key1) {
                return $state.current.name === key1;
            } else if (key2) {
                return $state.current.name === key2;
            }
            return false;
        }

        $scope.userLoggedIn = function(){
            return $scope.currentUser && null !== $scope.currentUser.authToken;
        };
    });