
var DOMAIN = {
    local: {
        baseUrl: 'http://anewhope:8080/cartissimaq8',
        sdkUrl: 'http://anewhope:8090/cartissimasdk',
        DPAY_SDK_APP_KEY: '7d90a9bb-98fd-4883-b01c-abd5da7683c3',
        ANDROID_CODE_PUSH_KEY: 'o9GTpGzLCoQwqrPASP0hxGnQaY5HBJ3VUQFyr',
        IOS_CODE_PUSH_KEY: 'NYKW-165YVfcakh7z9pkD5XGDZMOrk9987F1r',
        storeLocatorUrl: 'https://www.q8.it/geolocalizzatore'
    },
    test: {
        baseUrl: 'http://q8easyconsolesv.archeometra.it/cartissimaq8',
        sdkUrl: 'http://q8easyconsolesv.archeometra.it/cartissimasdk',
        DPAY_SDK_APP_KEY: '7d90a9bb-98fd-4883-b01c-abd5da7683c3',
        ANDROID_CODE_PUSH_KEY: 'o9GTpGzLCoQwqrPASP0hxGnQaY5HBJ3VUQFyr',
        IOS_CODE_PUSH_KEY: 'NYKW-165YVfcakh7z9pkD5XGDZMOrk9987F1r',
        storeLocatorUrl: 'https://www.q8.it/geolocalizzatore'
    },
    coll: {
        baseUrl: 'https://test.flotte.q8.it/cartissimaq8',
        sdkUrl: 'https://test.flotte.q8.it/cartissimasdk',
        DPAY_SDK_APP_KEY: '73a70fcd-e9a8-41a4-9bdd-40b0f780d184',
        ANDROID_CODE_PUSH_KEY: 'o9GTpGzLCoQwqrPASP0hxGnQaY5HBJ3VUQFyr',
        IOS_CODE_PUSH_KEY: 'NYKW-165YVfcakh7z9pkD5XGDZMOrk9987F1r',
        storeLocatorUrl: 'https://www.q8.it/geolocalizzatore'
    },
    prod: {
        baseUrl: 'https://www.flotte.q8.it/cartissimaq8',
        sdkUrl: 'https://www.flotte.q8.it/cartissimasdk',
        DPAY_SDK_APP_KEY: 'f55722db-6ab5-4555-9c06-c04536fcc36f',
        ANDROID_CODE_PUSH_KEY: 'U2AEtBtfJ9BTLKf60fWq9E7ci8YVr1-3EImtyr',
        IOS_CODE_PUSH_KEY: 'ovXvUL1rFzfmJ9e1puNKGe_qWvl1SkccU7FyH',
        storeLocatorUrl: 'https://www.q8.it/geolocalizzatore'
    }
};

var CONFIG = {
    defaultLat: 41.827037, // kupit
    defaultLon: 12.452827, // kupit
    defaultZoom: 18,
    gpsTimeout: 15000,
    HTTP_TIMEOUT: 15000,
    GPS_TIMEOUT: 5000,
    DPAY_POLLING: 5000,
    MIN_PWD_LENGTH: 6,
    analyticsTrackerId: 'UA-22371369-9',
    URL_SCHEMA: 'q8flottemobile',
    AROUND_ME: 0.05,
    FILTER_HISTORY_SIZE: 10,
    //WAREABLE_TEST: false,
    PUBLIC_JWT_TOKEN_PASS: { utf8: "3_A0g<c94{6]n2T" },
    LOY_PROGRAM: "TC_LOY_2018",
    DPAY_CARD_TYPE: "Cartissima",
    DPAY_DEFAULT: "DPAY",
    HOLD_APP_RESUME: false,  //disabilita la funzione resume del'app
    biometricLoginKey: "BIOMETRIC_LOGIN_KEY",
    biometricLoginExpirationPeriod: 1000*60*60,  //un'ora
    BACKGROUND_TASK_FREQUENCY: 60*1000 // ad ogni ora
};

function getEnv(){
    return retrieve("ambiente") || "prod";
}

function setEnv(ambiente){
    ambiente = ambiente || getEnv();
    CONFIG.context = DOMAIN[ambiente];
    CONFIG.apiUrl = CONFIG.context.baseUrl + '/api/mobile';
    console.log("Connected to " + ambiente + " [" + CONFIG.context.baseUrl + "]");
    store( "ambiente", ambiente );
}

var CACHE = {};
var PROFILEKEYS = {
    FAVORITE_PAYMENTS_CARD: 'keyFavPayPan',
    FAVORITE_PAYMENTS_CARD_NEVER_ASK_FLAG: 'flagFavPayPan',
    FAVORITE_PAYMENTS_TYPE: 'keyFavPayType'
};

function storeCurrentUser(profile){
    store("profile", profile);
}

/* utente correntemente loggato */
function getCurrentUser(){
    var profile = retrieve("profile");
    if ( null === profile || undefined === profile ) profile = {authToken: null};
    //profile.authToken = window.localStorage.getItem("token");
    return profile;
}

function storeLoggedUser(profile){
    store("loggedUser", profile);
}

function getLoggedUser(){
    return retrieve("loggedUser");
}

function store(key, value){
    window.localStorage.setItem(key, JSON.stringify(value));
}

function remove(key){
    window.localStorage.removeItem(key);
}

function retrieve(key){
    var ret = window.localStorage.getItem(key);

    if(ret) {
        try {
            return JSON.parse(ret);
        } catch(e) {
            remove(key);
            logger.error(e);
        }
    }

    return null;
}

function saveState(state){
    store("state", state.current.name);
}

function clearState(){
    window.localStorage.removeItem("state");
}

function resumeState() {
    return retrieve("state");
}

/**
 * rende persistenti i dati presenti nel LocalStorage in base alla mail dell'utete correntemente registrato
 */
function persistLocalStorage(){
    var profile = retrieve('profile');
    if (profile) {
        var profiledData = {};
        for (var i = 0; i < localStorage.length; i++) {
            profiledData[localStorage.key(i)] = retrieve(localStorage.key(i));
        }
        NativeStorage.setItem(profile.email,profiledData, function(storedData){
            console.info("persistLocalStorage data stored", storedData);
        }, function(error){
            console.error("persistLocalStorage", error);
        });
    }
}

/**
 * recupera i dati dalla persistenza e li mette a disposizione nel LocalStorage.
 * aggiorna il profile nel LocalStorage
 * @param profile
 */
function retrieveProfiledStoredData(profile){
    NativeStorage.getItem(profile.email, function(storedData){
        //recupero le informazioni
        console.info("retrieveStoredData data retrieved", storedData);
        for (var key in storedData) {
            store(key, storedData[key]);
        }
        //aggiorno il profilo
        store("profile", profile);
    }, function(error){
        console.warn("retrieveStoredData", error);
        //inserisco il profilo
        store("profile", profile);
    });

}

function emptyStorage(partial){
    //cancello tutto tranne l'ambiente e l'impostazione biometrica
    // partial = partial || false;

    var biometricEnabled = retrieve("biometric-login-protection-config");
    var profile = retrieve("profile");
    var ambiente = retrieve("ambiente");

        window.localStorage.clear();
    store("ambiente", ambiente);
    if (biometricEnabled) store ("biometric-login-protection-config", biometricEnabled);
    if (profile) store('lastUsername', profile.email);

    CACHE = {};
}

Object.size = function(obj) {
    var size = 0, key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};

/**
 * gestione degli url esterni per il resume dell'applicazione
 */
function handleOpenURL(url) {
    console.log("handleOpenURL received url: " + url);
    //imposto per prevenire un bug su android del plugin
    //https://github.com/EddyVerbruggen/Custom-URL-scheme/issues/42
    //console.log("handleOpenURL setting bypassSplash");
    //window.localStorage.setItem("bypassSplash", "true");

    if (url.lastIndexOf(CONFIG.URL_SCHEMA, 0) === 0 ){
        clearState(); //impedisce all'evento onResume di redirigere
        var forwardURL = url.substr((CONFIG.URL_SCHEMA+"://").length, url.length);
        console.log("handleOpenURL forwarding to: " + forwardURL);
        location.href = "#/"+forwardURL;
    }

}

function isTablet(){

    var agent = navigator.userAgent;
    var isWebkit = (agent.indexOf("AppleWebKit") > 0);
    var isIPad = (agent.indexOf("iPad") > 0);
    var isIOS = (agent.indexOf("iPhone") > 0 || agent.indexOf("iPod") > 0);
    var isAndroid = (agent.indexOf("Android")  > 0);
    var isNewBlackBerry = (agent.indexOf("AppleWebKit") > 0 && agent.indexOf("BlackBerry") > 0);
    var isWebOS = (agent.indexOf("webOS") > 0);
    var isWindowsMobile = (agent.indexOf("IEMobile") > 0);
    var isSmallScreen = (screen.width < 767 || (isAndroid && screen.width < 1000));
    var isUnknownMobile = (isWebkit && isSmallScreen);
    var isMobile = (isIOS || isAndroid || isNewBlackBerry || isWebOS || isWindowsMobile || isUnknownMobile);
    var isTablet = (isIPad || (isMobile && !isSmallScreen));

    //console.log("agent: "+agent);
    //console.log("isWebkit: "+isWebkit);
    //console.log("isIPad: "+isIPad);
    //console.log("isIOS: "+isIOS);
    //console.log("isAndroid: " + isAndroid);
    //console.log("isNewBlackBerry: " + isNewBlackBerry);
    //console.log("isWebOS: "+isWebOS);
    //console.log("isWindowsMobile: " + isWindowsMobile);
    //console.log("isSmallScreen: " + isSmallScreen);
    //console.log("isUnknownMobile: " + isUnknownMobile);
    //console.log("isMobile: " + isMobile);
    //console.log("isTablet: " + isTablet);
   return isTablet;
}

/**
 * inizializza un filtro di ricerca
 * @param filtro nome del filtro
 * @returns {*}
 */
function obtainCachedFilter(filtro){
    var cachedFilter = retrieve(filtro);
    if (null == cachedFilter) cachedFilter = [];
    return cachedFilter;
}

/**
 * imposta lo storico per il filtro di ricerca
 * @param filtro nome del filtro
 * @param $scope riferimento a $scope
 */
function setCachedFilter(filtro, $scope, model){
    //storico filtro ricerca:
    // max FILTER_HISTORY_SIZE elementi
    // l'ultimo usato per primo
    //devo fare una copia e usare angular.toJson per eliminare l'hash impostato da angular che duplicherebbe valori uguali nell'array

    var filtri = [];
    var index = -1;
    $scope.filtri;
    for (var i=0; i<$scope.filtri.length; i++){
        var _model = angular.toJson($scope.filtri[i]);
        if (_model == angular.toJson(model)) index = i;
        filtri.push(JSON.parse(_model));
    }

    if (filtri.length == CONFIG.FILTER_HISTORY_SIZE) filtri.pop();
    if (-1 != index) filtri.splice(index, 1);

    filtri.unshift(JSON.parse(angular.toJson(model)));  // JSON.parse per clonare l'oggetto
    store(filtro, filtri);
    $scope.filtri = filtri;

    $scope.model = model;
}

/**
 * genera un token della validità di 1 ora
 * @param oPayload
 * @returns {String}
 */
function jwtToken(oPayload){
    var oHeader = {alg: 'HS256', typ: 'JWT'};

    var tNow = KJUR.jws.IntDate.get('now');
    var tEnd = KJUR.jws.IntDate.get('now + 1hour');

    oPayload.nbf = tNow;
    oPayload.iat = tNow;
    oPayload.exp = tEnd;

    var sHeader = JSON.stringify(oHeader);
    var sPayload = JSON.stringify(oPayload);
    var sJWT = KJUR.jws.JWS.sign("HS256", sHeader, sPayload, CONFIG.PUBLIC_JWT_TOKEN_PASS);


    return sJWT;
}

function parseJwtToken(token){
    var decodedToken = KJUR.jws.JWS.parse(token);
    return decodedToken.payloadObj;
}

function trackView(screenName){
    console.info("entering", screenName);
    // if (window.analytics) window.analytics.trackView(screenName);
    if (window.FirebasePlugin) {
        window.FirebasePlugin.setScreenName(screenName);
        window.FirebasePlugin.logEvent("navigation", {content_type: "page_view", item_id: screenName});
    }
}


String.prototype.replaceAll = function(search, replacement) {
    var target = this;
    return target.replace(new RegExp(search, 'g'), replacement);
};

function hideMenuButton(){
	var dataMenuButtons = document.getElementsByClassName('data-menu-button');
	if (dataMenuButtons.length === 1) {
        dataMenuButtons[0].className += ' ng-hide';
        dataMenuButtons[0].className = dataMenuButtons[0].className.replace( /(?:^|\s)ng-show(?!\S)/g , '' );
    }
}

function showMenuButton(){
	var dataMenuButtons = document.getElementsByClassName('data-menu-button');
	if (dataMenuButtons.length === 1) {
        dataMenuButtons[0].className += ' ng-show';
        dataMenuButtons[0].className = dataMenuButtons[0].className.replace( /(?:^|\s)ng-hide(?!\S)/g , '' );
    }
}



/**
 * scriver un messaggio in un elemento html
 * @param el il riferimento all'elemento nel DOM
 * @param text il testo
 * @param error true | false
 */
function writeMessage (el, text, error){
    el.classList.remove('success');
    el.classList.remove('error');
    if (error) el.classList.add('error');
    else el.classList.add('success');
    el.innerHTML = text;
}

function disableAppResume(){
    console.log("disableAppResume");
    CONFIG.HOLD_APP_RESUME = true;
}

function enableAppResume(timeout){
    var timeout = timeout || 1000;
    setTimeout(function() {
        console.log("enableAppResume");
        CONFIG.HOLD_APP_RESUME = false;
    }, timeout)
}

function getPlatform() {
    var phoneType = 'unknown';
    var userAgent = navigator.userAgent || navigator.vendor || window.opera;

    if (userAgent.match( /iPad/i ) || userAgent.match( /iPhone/i ) || userAgent.match( /iPod/i ) )
        phoneType = 'ios';
    else if( userAgent.match( /Android/i ) )
        phoneType = 'android';

    return phoneType;
}

function isAndroid(){
    return getPlatform() === 'android';
}

function leftPadding(n){
    return String("00000" + n).slice(-5);
}

function testPlugins(){

    console.info("code-push................................",typeof window.codePush !== 'undefined');
    console.info("cordova-plugin-ionic-keyboard............",typeof window.Keyboard !== 'undefined');
    console.info("cordova-plugin-app-version...............",typeof cordova.getAppVersion !== 'undefined');
    console.info("cordova-plugin-badge.....................",typeof window.plugins.launchmyapp !== 'undefined');
    console.info("cordova-plugin-biometrictype.............",typeof window.plugins.biometrictype !== 'undefined');
    console.info("cordova-plugin-dialogs...................",typeof navigator.notification !== 'undefined');
    console.info("cordova-plugin-code-push.................",typeof codePush !== 'undefined');
    console.info("cordova-plugin-console...................",typeof console !== 'undefined');
    console.info("cordova-plugin-dpay-sdk..................",typeof window.DPaySDK !== 'undefined');
    console.info("cordova-plugin-file......................",typeof FileReader !== 'undefined');
    console.info("cordova-plugin-file-transfer.............",typeof FileTransfer !== 'undefined');
    console.info("cordova-plugin-firebase..................",typeof FirebasePlugin !== 'undefined');
    console.info("cordova-plugin-geolocation...............",typeof navigator.geolocation !== 'undefined');
    console.info("cordova-plugin-inappbrowser..............",typeof cordova.InAppBrowser !== 'undefined');
    console.info("cordova-plugin-keychain-touch-id.........",typeof window.plugins.touchid !== 'undefined');
    console.info("cordova-plugin-media.....................",typeof Media !== 'undefined');
    console.info("cordova-plugin-nativestorage.............",typeof NativeStorage !== 'undefined');
    console.info("cordova-plugin-screen-orientation........",typeof screen.orientation !== 'undefined');
    console.info("cordova-plugin-splashscreen..............",typeof navigator.splashscreen !== 'undefined');
    console.info("cordova-plugin-statusbar.................",typeof StatusBar !== 'undefined');
    console.info("cordova-plugin-zip.......................",typeof zip !== 'undefined');
    console.info("cordova-plugin-background-fetch..........",typeof window.BackgroundFetch !== 'undefined');
    console.info("cordova-plugin-device....................",typeof device !== 'undefined');
    console.info("cordova-plugin-local-notification........",typeof cordova.plugins.notification.local !== 'undefined');
    console.info("cordova-plugin-is-debug..................",typeof cordova.plugins.IsDebug !== 'undefined');
    console.info("cordova.plugins.diagnostic...............",typeof cordova.plugins.diagnostic !== 'undefined');
    console.info("cordova-plugin-is-debug..................",typeof cordova.plugins.IsDebug !== 'undefined');

}