angular.module('app.routes', ['pascalprecht.translate'])
    
.config(function ($stateProvider, $urlRouterProvider, $translateProvider) {

    loadLanguages($translateProvider);
    
    $stateProvider
    .state('main', {
        url: "/main",
        controller: 'MainCtrl'
    })

    .state('public-dashboard', {
        url: '/public-dashboard',
        controller: 'DashboardCtrl',
        templateUrl: 'templates/public-dashboard.html'
    })
    .state('private-dashboard', {
        controller: 'DashboardCtrl',
        templateUrl: 'templates/private-dashboard.html'
    })

    .state('login', {
        params: ['jusr','jpwd'],
        templateUrl: "templates/login.html",
        controller: 'LoginCtrl'
    })
    .state('login-biometric-setup', {
        params: ['jusr','jpwd'],
        templateUrl: 'templates/login_biometric_setup.html',
        controller: 'LoginBiometricSetupCtrl'
    })
    .state('notifiche', {
        url: '/notifiche',
        templateUrl: 'templates/profilo/notifiche.html',
        controller: 'NotificheCtrl'
    })
    .state('info', {
        url: '/info',
        templateUrl: 'templates/info/cartissima-servizi.html'
    })
    .state('cartissima-servizi', {
        url: '/cartissima-servizi',
        templateUrl: 'templates/info/cartissima-servizi.html'
    })
    .state('cartissima-flessibilita', {
        url: '/cartissima-flessibilita',
        templateUrl: 'templates/info/cartissima-flessibilita.html'
    })
    .state('cartissima-sicurezza', {
        url: '/cartissima-sicurezza',
        templateUrl: 'templates/info/cartissima-sicurezza.html'
    })
    .state('cartissima-network', {
        url: '/cartissima-network',
        templateUrl: 'templates/info/cartissima-network.html'
    })

    .state('credits', {
        url: '/credits',
        templateUrl: 'templates/info/credits.html'
    })

    .state('ricerca-carte', {
        params: ['askFavorite', 'domain'],
        templateUrl: "templates/carte/elenco.html",
        controller: 'CarteCtrl'
    })

    .state('ricerca-blocco-carte', {
        url: "/ricerca-blocco-carte",
        templateUrl: "templates/carte/elenco.html",
        controller: 'CarteCtrl'
    })
    .state('ricerca-generacodice-carte', {
        templateUrl: "templates/carte/elenco.html",
        controller: 'CarteCtrl'
    })
    .state('ricerca-storicocodici-carte', {
        templateUrl: "templates/carte/elenco.html",
        controller: 'CarteCtrl'
    })
    .state('ricerca-storico-sblocchi-dpay', {
        templateUrl: "templates/carte/elenco.html",
        controller: 'CarteCtrl'
    })
    .state('dpayment-punto-vendita', {
        params: ['pan'],
        templateUrl: "templates/dpayment/scelta-pv.html",
        controller: 'DPaySceltaPvCtrl'
    })
    .state('dpayment-rifornimento', {
        params: ['pan', 'pvCode'],
        templateUrl: "templates/dpayment/scelta-rifornimento.html",
        controller: 'DPaySceltaRifornimentoCtrl'
    })
    .state('dpayment-listapompe', {
        params: ['pan', 'pvCode', 'pump'],
        templateUrl: "templates/dpayment/lista-pompe.html",
        controller: 'DPayListaPompeCtrl'
    })
    .state('dpayment-erogazione', {
        params: ['dPayment', 'preAuth'],
        templateUrl: "templates/dpayment/stato-erogazione.html",
        controller: 'DPayErogazioneCtrl'
    })
    .state('ricerca-dpayment', {
        params: ['askFavorite', 'domain'],
        templateUrl: "templates/carte/elenco.html",
        controller: 'CarteCtrl'
    })
    .state('storicocodici-sblocchi-dpay', {
        controller: 'StoricoSblocchiDPayCtrl',
        templateUrl: "templates/dpayment/storico_sblocchi.html",
        params: ['pan']
    })
    .state('dettaglio-carta', {
        url: "/dettaglio-carta",
        controller: 'DettaglioCartaCtrl',
        templateUrl: "templates/carte/dettaglio.html"
    })
    .state('blocco-carta', {
        controller: 'BloccoCartaCtrl',
        templateUrl: "templates/carte/blocco.html",
        params: ['pan']
    })

    .state('generacodice-carte', {
        controller: 'GeneraCodiceCartaCtrl',
        templateUrl: "templates/carte/generacodice_carte.html",
        params: ['pan']
    })

    .state('storicocodici-carte', {
        controller: 'StoricoCodiciCartaCtrl',
        templateUrl: "templates/carte/storicocodici_carte.html",
        params: ['pan']
    })

    .state('ricerca-dashboard-pin-carta', {
        url: "/ricerca-dashboard-pin-carta",
        templateUrl: "templates/carte/elenco.html",
        controller: 'CarteCtrl'
    })

    .state('dashboard-pin', {
        templateUrl: "templates/security/dashboard_pin.html",
        controller: 'DashboardPinCtrl',
        params: ['pan']
    })

    .state('ricerca-pin-temporaneo-carta', {
        url: "/ricerca-pin-temporaneo-carta",
        templateUrl: "templates/carte/elenco.html",
        controller: 'CarteCtrl'
    })

    .state('pin-temporaneo-autista', {
        url: "/pin-temporaneo-autista",
        templateUrl: "templates/security/pin_autista_usa_e_getta.html",
        controller: 'PinUsaEGettaCtrl'
    })

    .state('pin-temporaneo-carta', {
        controller: 'PinUsaEGettaCtrl',
        templateUrl: "templates/security/pin_usa_e_getta.html",
        params: ['pan']
    })

    .state('ricerca-visualizza-pin', {
        url: "/ricerca-visualizza-pin",
        templateUrl: "templates/carte/elenco.html",
        controller: 'CarteCtrl'
    })

    .state('visualizza-pin-autisti', {
        templateUrl: "templates/autisti/elenco.html",
        controller: 'AutistiCtrl'
    })

    .state('visualizza-pin', {
        controller: 'VisualizzaPinCtrl',
        templateUrl: "templates/security/visualizza_pin.html",
        params: ['pan', 'codiceAutista']
    })

    .state('cambia-pin', {
        url: "/cambia-pin",
        controller: 'CambiaPinCtrl',
        templateUrl: "templates/security/cambia_pin.html"
    })

    .state('cambia-pin-results', {
        url: "/cambia-pin-results",
        controller: 'CambiaPinResultsCtrl',
        templateUrl: "templates/security/cambia_pin_results.html"
    })

    .state('storico-pin', {
        url: "/storico-pin",
        controller: 'StoricoPinCtrl',
        templateUrl: "templates/security/storico_pin.html"
    })

    .state('storico-pin-autista', {
        url: "/storico-pin-autista",
        controller: 'StoricoPinAutistaCtrl',
        templateUrl: "templates/autisti/storico_pin.html"
    })

    .state('transazioni-carta', {
        templateUrl: "templates/transazioni/elenco.html",
        controller: 'TransazioniCtrl',
        params: ['pan']
    })

    .state('ricerca-transazioni', {
        url: "/ricerca-transazioni",
        templateUrl: "templates/transazioni/elenco.html",
        controller: 'TransazioniCtrl'
    })

    .state('dettaglio-transazione', {
        url: "/dettaglio-transazione",
        controller: 'DettaglioTransazioneCtrl',
        templateUrl: "templates/transazioni/dettaglio.html"
    })

    .state('ricerca-alert', {
        url: "/ricerca-alert",
        templateUrl: "templates/alert/elenco.html",
        controller: 'AlertsCtrl'
    })

    .state('dettaglio-alert', {
        url: "/dettaglio-alert",
        controller: 'DettaglioAlertCtrl',
        templateUrl: "templates/alert/dettaglio.html"
    })

    .state('ricerca-alert-carta', {
        url: "/ricerca-alert-carta",
        templateUrl: "templates/alert/elenco_carta.html",
        controller: 'AlertCartaCtrl'
    })

    .state('dettaglio-alert-carta', {
        controller: 'DettaglioAlertCartaCtrl',
        templateUrl: "templates/alert/dettaglio_carta.html"
    })

    .state('ricerca-fatture', {
        url: "/ricerca-fatture",
        templateUrl: "templates/fatture/elenco.html",
        controller: 'FattureCtrl'
    })

    .state('lista-main', {
        url: "/lista-main",
        controller: "CambioMainCtrl",
        templateUrl: "templates/profilo/lista-main.html"
    })

    .state('profilo', {
        url: "/profilo",
        templateUrl:"templates/profilo/profile.html",
        controller: "ProfileCtrl"
    })
    .state('cambio-password', {
        url: "/cambio-password",
        templateUrl:"templates/profilo/cambio-password.html",
        controller: "CambioPasswordCtrl"
    })
    .state('privacy', {
        url: "/privacy",
        templateUrl:"templates/profilo/privacy.html",
        controller: "PrivacyCtrl"
    })
    .state('cambio-privacy', {
        url: "/cambio-privacy",
        templateUrl:"templates/profilo/privacy.html",
        controller: "CambioPrivacyCtrl"
    })
    .state('setup', {
        url: "/setup",
        templateUrl: "templates/setup.html",
        controller: 'SetupCtrl'
    })

    .state('waitingmail-forgotpwd', {
        url: "/waitingmail-forgotpwd",
        templateUrl: "templates/profilo/waitingmail-forgotpwd.html"
    })
    .state('forgot-password', {
        url: "/forgot-password",
        templateUrl: "templates/profilo/forgot-password.html",
        controller: 'ForgotPasswordCtrl'
    })
    .state('forgot-password-change-error', {
        url: "/forgot-password-change-error/:errorCode",
        templateUrl: "templates/profilo/forgot-password-change-error.html",
        controller: 'ForgotPasswordCtrl'
    })
    .state('forgot-password-change', {
        url: "/forgot-password-change/{token}/username/{username}",
        templateUrl: "templates/profilo/forgot-password-change.html",
        controller: 'ForgotPasswordCtrl'
    })
    .state('loyalty', {
        url: "/loyalty",
        templateUrl: "templates/loyalty/dashboard.html",
        controller: 'LoyaltyCtrl'
    })
    .state('loyalty-wallet', {
        url: "/loyalty-wallet",
        templateUrl: "templates/loyalty/wallet.html",
        controller: 'LoyaltyWalletCtrl'
    })
    .state('loyalty-reward', {
        url: "/loyalty-reward",
        templateUrl: "templates/loyalty/rewards.html",
        controller: 'LoyaltyRewardCtrl'
    })
    ;

});
