angular.module('app.services')

  .service('CarteService', function($http, $ionicLoading, $ionicPopup, $translate) {

      this.currentCard = {};

    return {
      ricerca: function(form, pageIndex) {

        $ionicLoading.show();

        var profile = getCurrentUser();
        var url = CONFIG.apiUrl + '/carte';
        if (pageIndex){
          url += '/'+pageIndex;
        }

        return $http.post(url,
          {
            token: profile.authToken,
            sub: form.sub,
            pan: form.pan,
            statoBlocco: form.statoBlocco
          },
            { timeout: CONFIG.HTTP_TIMEOUT }
        ).success(function (response) {
          $ionicLoading.hide();
          if (response.errorMessage != null) {
            console.log(response.errorMessage);
          }
        }).error(function(data, status, headers, config){

            // console.error("data", data);
            // console.error("status", status);
            // console.error("headers", headers);
            // console.error("config", config);

          $ionicLoading.hide();
            $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                title: $translate.instant("alert-title-attenzione")});
        });
      },
      plafond: function(pan) {

        $ionicLoading.show();

        var profile = getCurrentUser();

        return $http.post(CONFIG.apiUrl + '/carte/plafond/'+pan,
          {
            token: profile.authToken,
          },
            { timeout: CONFIG.HTTP_TIMEOUT }
        ).success(function (response) {
          $ionicLoading.hide();
          if (response.errorMessage != null) {
            console.log(response.errorMessage);
          }
        }).error(function(){
          $ionicLoading.hide();
            $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                title: $translate.instant("alert-title-attenzione")});
        });
      },
      causaliBlocco: function() {

        //$ionicLoading.show();

        var profile = getCurrentUser();

        return $http.post(CONFIG.apiUrl + '/carte/causaliBlocco',
          {
            token: profile.authToken
          },
            { timeout: CONFIG.HTTP_TIMEOUT }
        ).success(function (response) {
          //$ionicLoading.hide();
          if (response.errorMessage != null) {
            console.log(response.errorMessage);
          }
        }).error(function(){
          //$ionicLoading.hide();
            $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                title: $translate.instant("alert-title-attenzione")});
        });
      },
      blocca: function(data) {

        //$ionicLoading.show();

        var profile = getCurrentUser();

        return $http.post(CONFIG.apiUrl + '/carte/blocco',
          {
            token: profile.authToken, pan: data.pan, motivazione: data.causaleBlocco
          },
            { timeout: CONFIG.HTTP_TIMEOUT }
        ).success(function (response) {
          //$ionicLoading.hide();
          if (response.errorMessage != null) {
            console.log(response.errorMessage);
          }
        }).error(function(){
          //$ionicLoading.hide();
            $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                title: $translate.instant("alert-title-attenzione")});
        });
      },
      sblocca: function(data) {

        //$ionicLoading.show();

        var profile = getCurrentUser();

        return $http.post(CONFIG.apiUrl + '/carte/sblocco',
          {
            token: profile.authToken, pan: data.pan, targa: data.targa
          },
            { timeout: CONFIG.HTTP_TIMEOUT }
        ).success(function (response) {
          //$ionicLoading.hide();
          if (response.errorMessage != null) {
            console.log(response.errorMessage);
          }
        }).error(function(){
          //$ionicLoading.hide();
            $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                title: $translate.instant("alert-title-attenzione")});
        });
      },
      numeroCarteBySub: function(sub){

        var profile = getCurrentUser();
        return $http.get(CONFIG.apiUrl + "/carte/count",
          { params: {
            "token": profile.authToken,
            "sub": sub
          }}).then(function (response) {
          if (response.data) {
            return response.data;
          }
        });

      }

    }
  })

;

