angular.module('app.services')

    .service('CodiciCarteService', function ($http, $ionicPopup, $translate) {

        this.getStatoCodici = function (pan) {

            var profile = getCurrentUser();

            return $http.post(CONFIG.apiUrl + "/pagamenti/stato_codice",
                { token: profile.authToken, pan: pan },
                { timeout: CONFIG.HTTP_TIMEOUT }).then(
                function (response) {
                    return response.data;
                }, function(error){
                    console.log("ERROR getStatoCodici " + JSON.stringify( error ));
                    return { errorMessage: "error.service.not.available" }
                });


        }
        
        this.generaCodice = function (pan, kmVeicolo, minuti) {

            var profile = getCurrentUser();

            return $http.post(CONFIG.apiUrl + '/pagamenti/genera_codice',
                { token: profile.authToken, pan: pan, kmVeicolo: kmVeicolo, min: minuti },
                { timeout: CONFIG.HTTP_TIMEOUT*2 }).then(
                function (response) {
                    return response.data;
                }, function(error){
                    console.log("ERROR generaCodice " + JSON.stringify( error ));
                    return { errorMessage: "error.service.not.available" }
                });
        }       
        
        this.annullaCodice = function (codice, pan) {

            var profile = getCurrentUser();

            return $http.post(CONFIG.apiUrl + '/pagamenti/annulla_codice',
                { token: profile.authToken, codice: codice, pan: pan },
                { timeout: CONFIG.HTTP_TIMEOUT*2 }).then(
                function (response) {
                    return response.data;
                }, function(error){
                    console.log("ERROR annullaCodice " + JSON.stringify( error ));
                    return { errorMessage: "error.service.not.available" }
                });
        }

        this.getListaCodici = function (pan) {

            var profile = getCurrentUser();

            return $http.post(CONFIG.apiUrl + '/pagamenti/lista_codici',
                { token: profile.authToken, pan: pan },
                { timeout: CONFIG.HTTP_TIMEOUT }).then(
                function (response) {
                    return response.data;
                }, function(error){
                    console.log("ERROR getListaCodici " + JSON.stringify( error ));
                    return { errorMessage: "error.service.not.available" }
                });
        }
        
    })

;

