angular.module('app.services')

  .service('FattureService', function($http, $ionicLoading, $ionicPopup, $translate) {
    return {
      ricerca: function(form) {

        $ionicLoading.show();

        var profile = getCurrentUser();

        return $http.post(CONFIG.apiUrl + '/fatture',
          {
            token: profile.authToken,
            sub: form.sub,
            anno: form.anno,
            mese: form.mese
          }
        ).success(function (response) {
          $ionicLoading.hide();
          if (response.errorMessage != null) {
            console.log(response.errorMessage);
          }
        }).error(function(data, status, headers, config){
          $ionicLoading.hide();
            $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                title: $translate.instant("alert-title-attenzione")});
        });
      },
      download: function(fattura) {
        // var date = new Date(fattura.data);  //ddMMyyyy
        //
        // var day = date.getDate() < 10 ? "0"+date.getDate() : date.getDate();
        // var month = date.getMonth() < 9 ? "0"+(date.getMonth()+1) : (date.getMonth()+1);
        // var year = date.getFullYear();
        //
        // var data = ""+day+month+year;

        //utilizzo dataFormattata per evitare problemi legati al timezone
        //dataformattata: dd/MM/yyyy
        var data = fattura.dataFormattata.replaceAll('/','');

        var token = encodeURIComponent(getCurrentUser().authToken);
        var url = CONFIG.apiUrl + '/fattura/'+fattura.numero+'/'+data+'/pdf?token='+token;
        console.log("FattureService calling " + url);

        if (window.device.platform.toLowerCase() == "ios") {
          window.open(url , '_system', 'location=no,hidden=no,enableViewportScale=yes');
        } else {

          var storageLocation = 'file:///storage/emulated/0/Download';
          var localFileURL = "cdvfile://localhost/persistent/download/"+fattura.numero+".pdf";

          window.resolveLocalFileSystemURL(storageLocation+"/"+fattura.numero+".pdf", function(fileEntry){
            window.open(storageLocation+"/"+fattura.numero+".pdf", "_system", 'location=no,hidden=no,enableViewportScale=yes');
          }, function(){
            //file not found in storageLocation, check local
            window.resolveLocalFileSystemURL(localFileURL, function(fileEntry){

                  window.resolveLocalFileSystemURL(storageLocation, function(_storageLocation) {

                    //copy to storageLocation
                    fileEntry.moveTo(_storageLocation, fattura.numero + ".pdf", function () {
                      console.log("download complete: " + entry.toURL());
                      window.open(storageLocation + "/" + fattura.numero + ".pdf", "_system", 'location=no,hidden=no,enableViewportScale=yes');
                    }, function () {
                      window.open(url, '_system', 'location=no,hidden=no,enableViewportScale=yes');
                    });
                  });

                }, function (){
                  //file not found in local: download
                  var fileTransfer = new FileTransfer();
                  fileTransfer.download(
                      url,
                      localFileURL,
                      function (entry) {

                        window.resolveLocalFileSystemURL(storageLocation, function(_storageLocation) {

                          entry.moveTo(_storageLocation, fattura.numero + ".pdf", function () {
                            console.log("download complete: " + entry.toURL());
                            window.open(storageLocation + "/" + fattura.numero + ".pdf", "_system", 'location=no,hidden=no,enableViewportScale=yes');
                          }, function () {
                            window.open(url, '_system', 'location=no,hidden=no,enableViewportScale=yes');
                          });
                        });

                      },
                      function (error) {
                          console.log("Unable to download file", error);
                        //unable to load, open directly from url
                        window.open(url , '_system', 'location=no,hidden=no,enableViewportScale=yes');
                      });
                }
            )

          });










          // //controllo che il file sia presente
          // //var reader = new FileReader();
          // var fileURL = "cdvfile://localhost/persistent/download/"+fattura.numero+"_"+data+".pdf";
          //
          // // We are going to check if the file exists
          // //reader.readAsDataURL(fileURL);
          // return window.resolveLocalFileSystemURL(fileURL, function(fileEntry){
          //
          //     //var localFileURL = fileURL.replace("cdvfile://localhost", "file://sdcard0");
          //     console.log("opening: " + fileEntry.toURL());
          //     window.open(fileEntry.toURL(), "_system", 'location=no,hidden=no,enableViewportScale=yes')
          //   }, function (){
          //     var fileTransfer = new FileTransfer();
          //     fileTransfer.download(
          //       CONFIG.apiUrl + "/fattura/"+fattura.numero+"/"+data+"/pdf?token="+token,
          //       fileURL,
          //       function (entry) {
          //         console.log("download complete: " + entry.toURL());
          //         window.open(entry.toURL(), "_system", 'location=no,hidden=no,enableViewportScale=yes');
          //       },
          //       function (error) {
          //         window.open(CONFIG.apiUrl + '/fattura/'+fattura.numero+'/'+data+'/pdf?token='+token , '_blank', 'location=no,hidden=no,enableViewportScale=yes');
          //         console.log("download error source " + error.source);
          //         console.log("download error target " + error.target);
          //         console.log("upload error code" + error.code);
          //       });
          //   }
          // )
        }

      }

    }
  })

;

