angular.module('app.services')

  .service('LoyaltyService', function($http, $ionicLoading, $state, $translate) {

      this.checkPrivacy = function(){

          var profile = getCurrentUser();

          return $http.get(CONFIG.apiUrl + "/loyalty/privacy/check",
              { params: { token: profile.authToken, tc: CONFIG.LOY_PROGRAM }},
              { timeout: CONFIG.HTTP_TIMEOUT }).then(
              function (response) {
                  return response.data;
              }, function(error){
                  console.log("ERROR checkPrivacy " + JSON.stringify(error));
                  return {
                      errorMessage: $translate.instant("error.service.not.available")
                  }
              });
      };

      this.confirmPrivacy = function(formData){

          var profile = getCurrentUser();

          return $http.post(CONFIG.apiUrl + "/loyalty/privacy/confirm",
              { token: profile.authToken, tcConfim1: formData.tcConfim1, tc: CONFIG.LOY_PROGRAM },
              { timeout: CONFIG.HTTP_TIMEOUT }).then(
              function (response) {
                  return response.data;
              }, function(error){
                  console.log("ERROR confirmPrivacy " + JSON.stringify(error));
                  return {
                      errorMessage: $translate.instant("error.service.not.available")
                  }
              });
      };

      this.loadWallet = function(pageNumber){

          var profile = getCurrentUser();

          return $http.post(CONFIG.apiUrl + "/loyalty/wallet",
              { token: profile.authToken, pageSize: 20, pageIndex: pageNumber },
              { timeout: CONFIG.HTTP_TIMEOUT }).then(
              function (response) {
                  return response.data;
              }, function(error){
                  console.log("ERROR confirmPrivacy " + JSON.stringify(error));
                  return {
                      errorMessage: $translate.instant("error.service.not.available")
                  }
              });
      };

      this.loadRewards = function(pageNumber){

          var profile = getCurrentUser();

          return $http.post(CONFIG.apiUrl + "/loyalty/rewards",
              { token: profile.authToken, pageSize: 20, pageIndex: pageNumber },
              { timeout: CONFIG.HTTP_TIMEOUT }).then(
              function (response) {
                  return response.data;
              }, function(error){
                  console.log("ERROR confirmPrivacy " + JSON.stringify(error));
                  return {
                      errorMessage: $translate.instant("error.service.not.available")
                  }
              });
      };


  })

;

