angular.module('app.services')

	.service('SecurityService', function ($http, $state, $ionicPopup, $translate) {
		return {
			cambiaPin: function (form) {
				var profile = getCurrentUser();

				return $http.post(
					CONFIG.apiUrl + '/v2/carte/pin/modifica',
					{
						token: profile.authToken,
						codiciSub: form.codiciSub.toString(),
						pan: form.pan,
						tipoPin: form.tipoPin,
						nuovoPIN: form.nuovoPIN,
						confermaNuovoPIN: form.confermaNuovoPIN,
						dataFineScadenzaCarta: form.dataFineScadenzaCarta,
						dataInizioValidita: form.dataInizioValidita,
						dataFineValidita: form.dataFineValidita,
						minutiValidita: form.minutiValidita,
						numeroUtilizzi: form.numeroUtilizzi,
						email: form.canaleEmail,
						cellulare: form.canaleSms,
						t: form.t	//tipo pin carta
					},
					{timeout: CONFIG.HTTP_TIMEOUT}
				)
				.success(function (response) {
					return response;
				})
				.error(function (data, status, headers, config) {
					if (status === 401) {
						// Unauthorized
						// $ionicPopup.alert({template: $translate.instant("dashboard-pin-unathorized"),
						// 	title: $translate.instant("alert-title-attenzione")}).then(function(){
						// 	$state.go('login');
						// });

					} else {
						$ionicPopup.alert({template: $translate.instant("dashboard-pin-unathorized"),
                        title: $translate.instant("alert-title-attenzione")});
                     }
				});
			},

			cambiaPinAutista: function (form) {
				var profile = getCurrentUser();

				return $http.post(
					CONFIG.apiUrl + '/v2/carte/pin/autista/modifica',
					{
						token: profile.authToken,
						codiceSub: profile.codiceSub,
						codiceMain: profile.codiceMain,
						codiciAutisti: form.codiciAutisti.toString(),
						tipoPin: form.tipoPin,
						nuovoPIN: form.nuovoPIN,
						confermaNuovoPIN: form.confermaNuovoPIN,
						dataFineScadenzaCarta: form.dataFineScadenzaCarta,
						dataInizioValidita: form.dataInizioValidita,
						dataFineValidita: form.dataFineValidita,
						minutiValidita: form.minutiValidita,
						numeroUtilizzi: form.numeroUtilizzi,
						email: form.canaleEmail,
						cellulare: form.canaleSms
					},
					{timeout: CONFIG.HTTP_TIMEOUT}
				)
				.success(function (response) {
					return response;
				})
				.error(function (data, status, headers, config) {
					if (status === 401) {
						// Unauthorized
						// $state.go('login');
					} else {
						$ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                        title: $translate.instant("alert-title-attenzione")});
                    }
				});
			},

			storicoPin: function (form, pageIndex) {
				var profile = getCurrentUser();
				var url = CONFIG.apiUrl + '/v2/carte/pin/storico';
				if (pageIndex) {
					url += '/' + pageIndex;
				}

				return $http.post(url,
					{
						token: profile.authToken,
						sub: form.sub,
						pan: form.pan,
						codice: form.codice,
						periodo: form.periodo,
						tipoPin: form.tipoPin
					},
					{timeout: CONFIG.HTTP_TIMEOUT}
				)
				.success(function (response) {
					if (response.errorMessage != null) {
						console.log(response.errorMessage);
					}
					return response;
				})
				.error(function (data, status, headers, config) {
                    $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                        title: $translate.instant("alert-title-attenzione")});
				});
			},

			richiestaVisualizzaPin: function (pan) {
				var profile = getCurrentUser();

				return $http.get(CONFIG.apiUrl + "/carte/" + pan + "/visualizza/pin",
					{params: {"token": profile.authToken}}).then(function (response) {
					if (response.data) {
						return response.data;
					}
				});
			},

			richiestaVisualizzaPinAutista: function (codiceAutista) {
				var profile = getCurrentUser();

				return $http.get(CONFIG.apiUrl + "/v2/autisti/" + codiceAutista + "/visualizza/pin",
					{params: {"token": profile.authToken}}).then(function (response) {
					if (response.data) {
						return response.data;
					}
				});
			},

			confermaVisualizzaPin: function (form, codiceControllo, isPinAutista) {
				var oPayload = {jpwd: form.password, codice: codiceControllo};
				var token = jwtToken(oPayload);
				var profile = getCurrentUser();
				var url = CONFIG.apiUrl + (isPinAutista ? '/v2/autisti' : '/carte') + '/visualizza/pin';

				return $http.post(url,
					{
						token: profile.authToken,
						mobiletoken: token
					},
					{timeout: CONFIG.HTTP_TIMEOUT}
				)
				.success(function (response) {
					if (response.errorMessage != null) {
						console.log(response.errorMessage);
					}
					return response;
				});
			},

			generaPinTemporaneo: function (pan) {
				var profile = getCurrentUser();

				return $http.post(CONFIG.apiUrl + '/v2/carte/generapin',
					{
						token: profile.authToken,
						pan: pan
					},
					{timeout: CONFIG.HTTP_TIMEOUT}
				)
				.success(function (response) {
					if (response.errorMessage !== null) {
						console.log(response.errorMessage);
					}
					return response;
				})
				// .error(function (error) {
                 //    return { data: { errorMessage: 'TIMEOUT' } };
                //
				// });
			},

			generaPinAutistaTemporaneo: function (codice, tipoPin) {
				var profile = getCurrentUser();

				return $http.post(CONFIG.apiUrl + '/v2/carte/autista/generapin',
					{
						token: profile.authToken,
						codice: codice,
						t: tipoPin
					},
					{timeout: CONFIG.HTTP_TIMEOUT}
				)
				.success(function (response) {
					if (response.errorMessage !== null) {
						console.log(response.errorMessage);
					}
					return response;
				})
				// .error(function (error) {
                 //    $ionicPopup.alert({template: $translate.instant("html.cartissima.generacodice.error.code.99"),
                 //        title: $translate.instant("alert-title-attenzione")});
				// });
			}
		}
	});

