function loadLanguages($translateProvider){
    //$translateProvider.useSanitizeValueStrategy('sanitize');

	$translateProvider.useSanitizeValueStrategy(null);

    $translateProvider.useStaticFilesLoader({
        prefix: 'i18n/locale-',
        suffix: '.json'
    });

    $translateProvider.preferredLanguage('en');
}

function selectCurrentLanguage($translate) {
    if (navigator.globalization) {
        //app
        navigator.globalization.getPreferredLanguage(
            function (language) {
                var lang = language.value.substring(0, 2);
                $translate.use(lang);
            },
            function () {
                console.log('Error getting language: setting en-US');
                $translate.use('en');
            }
        );
    } else if (navigator.language) {
        console.log('Navigator language: ' + navigator.language + " -> " + navigator.language.substring(0, 2));
        //browser
        $translate.use(navigator.language.substring(0, 2));
    } else {
        //other
        console.log('Browser, getting language: en-US -> en');
        $translate.use("en");
    }

}






