function Watch(handle) {
    var self = this;
    self.handle = handle;
    if (window.AndroidWear){
        AndroidWear.onDataReceived(handle, function(e) {
            console.log("Data received - handle: " + handle + " data: " + e.data);
            self.dataReceived(e.data);
            wearable.blocca(e.data);
        });
    }

    if (window.applewatch){
        applewatch.addListener("myqueue", function(message) {
            alert("Message received: " + message);
            self.dataReceived(message);
            wearable.blocca(emessage);
        });
    }

}
Watch.prototype = {
    dataReceived: function(data) {
        console.log("dataReceived message received: " + data);
        //data."extras": { "type": "blocco", "pan": "1234567890" }

    },
    sendMessage: function(message) {
        console.log("send message " + message);

        if (window.AndroidWear){
            AndroidWear.sendData(this.handle, message,
                function (e) {
                    console.log("sendData SUCCESS " + e);
                },
                function (e) {
                    console.log("sendData FAILURE " + e);
                });
        }

        if (window.applewatch){
            applewatch.registerNotifications(function(){

            var payload = {
                "title": "Short!",
                "body": "Shown in the long-look interface to provide more detail",
                "badge": 1
            };

            applewatch.sendNotification("myqueue",
                 function () {
                     console.log("sendMessage SUCCESS ");
                 },
                 function () {
                     console.log("sendMessage FAILURE ");
                 },
                 payload);

            }, function () {
                console.log("registerNotifications FAILURE ");
            });

        }
    }
};

var wearable = {

    watch: null,
    http: null,

    initialize: function(options) {

        console.log("wearable initialize...");

        var self = this;
        if (options.httpHandle) self.http = options.httpHandle;

        if(window.AndroidWear) {
            AndroidWear.onConnect(function(e) {
                console.log("AndroidWear connection established:" + e.handle);
                self.watch = new Watch(e.handle);
            });
        }

        if (window.applewatch){
            applewatch.init(function (appGroupId) {
                console.log("applewatch connection established: " + appGroupId);
                self.watch = new Watch(appGroupId);
            });
        }
    },
    sendMessage: function(message){
        console.log("wearable.sendMessage " + message);
        var self = this;
        if (self.watch){
            self.watch.sendMessage(message);
        }
    },
    blocca: function(pan) {
        var self = this;
        var profile = getCurrentUser();
        return self.http.post(CONFIG.apiUrl + '/carte/blocco',{
                token: profile.authToken, pan: pan, motivazione: "08"
            }).success(function (response) {
                if (response.errorMessage != null) {
                    console.log(response.errorMessage);
                } else {
                    console.log("Carta " + pan + " bloccata");
                }
            }).error(function(error){
                console.log(error);
        });
    },
    test: function(){
        var self = this;
        var message = '{ "message": "Test da Cartissima! ' + new Date() +'", "extras": { "type": "blocco", "pan": "1234567890" } }';
        self.sendMessage(message);
    }

};

