cordova.define("cordova-plugin-dpay-sdk.DPaySDK", function(require, exports, module) {
"use strict";
/*
 * Copyright 2015 Matt Parsons
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
var exec = require('cordova/exec');
var DPaySDK = {

  initializeSdk: function (authKey, env, cardType, win, fail) {
    exec(win, fail, 'DPaySDK', 'initializeSdk', [authKey, env, cardType]);
  },

    fuelingPoints: function (userToken, storeNumber, win, fail) {
    exec(win, fail, 'DPaySDK', 'fuelingPoints', [userToken, storeNumber]);
  },

    startPayment: function (userToken, trxId, storeNumber, fuelingpointId, pan, vehicleKilometers, win, fail) {
    exec(win, fail, 'DPaySDK', 'startPayment', [userToken, trxId, storeNumber, fuelingpointId, pan, vehicleKilometers]);
  },

    abortPayment: function (userToken, trxId, win, fail) {
    exec(win, fail, 'DPaySDK', 'abortPayment', [userToken, trxId]);
  },

    paymentStatus: function (userToken, trxId, pan, win, fail) {
    exec(win, fail, 'DPaySDK', 'paymentStatus', [userToken, trxId, pan]);
  },

    lastTransaction: function (userToken, pan, win, fail) {
    exec(win, fail, 'DPaySDK', 'lastTransaction', [userToken, pan]);
  },

    transactionsHistory: function (userToken, pan, win, fail) {
    exec(win, fail, 'DPaySDK', 'transactionsHistory', [userToken, pan]);
  },

    pvAround: function (lat, lng, radius, win, fail) {
    exec(win, fail, 'DPaySDK', 'pvAround', [lat, lng, radius]);
  },

  version: function (win, fail) {
    exec(win, fail, 'DPaySDK', 'version', []);
  },

  Environment: { LOCAL: "LOCAL", COLL: "COLL", PROD: "PROD" }
};
module.exports = DPaySDK;

});
